Attribute VB_Name = "modAllPurpose"
'
' ****************************************************************
' ****************************************************************
' ****************************************************************
' This program is free software: you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' version 3 as published my the Free Software Foundation:
' http://www.gnu.org/licenses/gpl.html
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' This software was originally written by Elroy Sullivan, PhD in
' cooperation with Shriners Hospitals for Children, Houston.
' Dr. Sullivan can be reached at elroysullivan@gmail.com.
' ****************************************************************
' ****************************************************************
' ****************************************************************
'
Option Explicit
' Junk variables for use in Debug window.
Public lJunk1 As Long
Public lJunk2 As Long
Public lJunk3 As Long
Public lJunk4 As Long
Public bbJunk1 As Byte
' General
Public Const TwipsPerInch = 1440
Public Const dtFirstDate As Date = #1/1/1000#
Public Const dtLastDate As Date = #12/31/9999#
' SetWindowPos Flags
Private Const SWP_NOSIZE = &H1
Private Const SWP_NOMOVE = &H2
Private Const SWP_NOZORDER = &H4
Private Const SWP_NOREDRAW = &H8
Private Const SWP_NOACTIVATE = &H10
Private Const SWP_FRAMECHANGED = &H20        '  The frame changed: send WM_NCCALCSIZE
Private Const SWP_SHOWWINDOW = &H40
Private Const SWP_HIDEWINDOW = &H80
Private Const SWP_NOCOPYBITS = &H100
Private Const SWP_NOOWNERZORDER = &H200      '  Don't do owner Z ordering
Private Const SWP_DRAWFRAME = SWP_FRAMECHANGED
Private Const SWP_NOREPOSITION = SWP_NOOWNERZORDER
' SetWindowPos() hwndInsertAfter values
Private Const HWND_TOP = 0
Private Const HWND_BOTTOM = 1
Private Const HWND_TOPMOST = -1
Private Const HWND_NOTOPMOST = -2
'
Type POINTAPI
    X As Long
    Y As Long
End Type
Type msg
    hWnd As Long
    message As Long
    wParam As Long
    lParam As Long
    Time As Long
    pt As POINTAPI
End Type
'
' For getting absolute (screen) control positions (in pixels).
Private Type RECT
        Left As Long
        Top As Long
        Right As Long ' This is +1 (right - left = width)
        Bottom As Long ' This is +1 (bottom - top = height)
End Type
Private Type SAFEARRAY
    cDims As Integer
    fFeatures As Integer
    cbElements As Long
    cLocks As Long
    pvData As Long
End Type
' API calls.
Private Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hWnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
Private Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Private Declare Function GetDiskFreeSpace Lib "kernel32" Alias "GetDiskFreeSpaceA" (ByVal lpRootPathName As String, lpSectorsPerCluster As Long, lpBytesPerSector As Long, lpNumberOfFreeClusters As Long, lpTtoalNumberOfClusters As Long) As Long
Private Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Private Declare Function GetProfileString Lib "kernel32" Alias "GetProfileStringA" (ByVal lpAppName As String, ByVal lpKeyName As String, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long) As Long
Private Declare Function OpenProcess Lib "kernel32" (ByVal dwDesiredAccess As Long, ByVal bInheritHandle As Long, ByVal dwProcessId As Long) As Long
Private Declare Function WaitForSingleObject Lib "kernel32" (ByVal hHandle As Long, ByVal dwMilliseconds As Long) As Long
Private Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpString As Any, ByVal lpFileName As String) As Long
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)
'
Public Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
'

Public Sub ChangeTheSSTab(SSctl As Control, ctl() As Control, OldTab As Long, NewTab As Long, Optional bRestoreTheTab As Boolean = False)
    ' Hide the form with the SSTab before doing this.
    ' You must get the OldTab correct or everything blows up.
    ' Alternatively, this procedure could have "found" it, but that wastes time.
    ' This procedure does NOT work in form_load, but it DOES work in form_activate.
    ' Also, when using this, don't forget to deal with the TabIndex if you need to !!!!
    Dim OrigTab As Long
    Dim i As Long
    '
    If bRestoreTheTab Then OrigTab = SSctl.Tab
    '
    SSctl.Tab = OldTab
    For i = LBound(ctl) To UBound(ctl)
        If TypeName(ctl(i)) = "Line" Then
            ctl(i).X1 = ctl(i).X1 - 75000
            ctl(i).x2 = ctl(i).x2 - 75000
        Else
            ctl(i).Left = ctl(i).Left - 75000
        End If
    Next i
    SSctl.Tab = NewTab
    For i = LBound(ctl) To UBound(ctl)
        If TypeName(ctl(i)) = "Line" Then
            ctl(i).X1 = ctl(i).X1 + 75000
            ctl(i).x2 = ctl(i).x2 + 75000
        Else
            ctl(i).Left = ctl(i).Left + 75000
        End If
    Next i
    '
    If bRestoreTheTab Then SSctl.Tab = OrigTab
End Sub

Public Sub SwapControlPos(ctl1 As Control, ctl2 As Control)
    ' This procedure swaps the positions and tabindexes (if available) of two controls.
    ' When dealing with the SSTab control, it's much better to be on the tab where the controls are being swapped.
    Dim Left1 As Long
    Dim Left2 As Long
    Dim Top1 As Long
    Dim Top2 As Long
    Dim TabIndex1 As Long
    Dim TabIndex2 As Long
    '
    TabIndex1 = -1
    TabIndex2 = -1
    '
    On Error Resume Next
    TabIndex1 = ctl1.TabIndex
    TabIndex2 = ctl2.TabIndex
    On Error GoTo 0
    '
    Left1 = ctl1.Left
    Left2 = ctl2.Left
    Top1 = ctl1.Top
    Top2 = ctl2.Top
    '
    ctl1.Left = Left2
    ctl1.Top = Top2
    ctl2.Left = Left1
    ctl2.Top = Top1
    '
    If (TabIndex1 <> -1) And (TabIndex2 <> -1) Then
        ctl1.TabIndex = 9999
        ctl2.TabIndex = 9999
        If TabIndex1 < TabIndex2 Then ' Make sure we assign them in the correct order to make it work correctly.
            ctl2.TabIndex = TabIndex1
            ctl1.TabIndex = TabIndex2
        Else
            ctl1.TabIndex = TabIndex2
            ctl2.TabIndex = TabIndex1
        End If
    End If
    '
    ' Deal with right-justified labels.
    If TypeName(ctl1) = "Label" Then
        If ctl1.Alignment = 1 Then
            If ctl1.Width <> ctl2.Width Then
                ctl1.Left = ctl1.Left + (ctl2.Width - ctl1.Width)
                ctl2.Left = ctl2.Left + (ctl1.Width - ctl2.Width)
            End If
        End If
    End If
End Sub

Public Function SafeDir(sSpec As String, Optional Attributes As VbFileAttribute = vbNormal) As String
    On Error Resume Next
    SafeDir = Dir$(sSpec, Attributes)
    On Error GoTo 0
End Function

Public Function SafeDirNoDotDblDot(sSpec As String, Optional Attributes As VbFileAttribute = vbNormal) As String
    Dim s As String
    '
    On Error Resume Next
    s = Dir$(sSpec, Attributes)
    Do
        If s <> "." And s <> ".." Then Exit Do
        s = Dir$
    Loop
    On Error GoTo 0
    SafeDirNoDotDblDot = s
End Function

Public Sub HyperLinkJump(ByVal sUrl As String, hWnd As Long)
    Dim s As String
    Dim iFle As Long
    Dim sFle As String
    '
    s = ApiSpecialFolder(CSIDL_LOCAL_APPDATA)
    If bFileExists(s & "Google\Chrome\Application\Chrome.exe") Then ' Chrome will NOT work with VB6 hyperlinks.
        s = "C:\Program Files\Internet Explorer\iexplore.exe"
        If bFileExists(s) Then
            Shell Chr$(34) & s & Chr$(34) & " " & Chr$(34) & sUrl & Chr$(34), vbNormalFocus
        Else
            ShellExecute hWnd, "open", sUrl, "", "c:\\", vbNormalFocus
        End If
    Else
        ShellExecute hWnd, "open", sUrl, "", "c:\\", vbNormalFocus
    End If
End Sub

Public Sub TrimIt(s As String)
    s = Trim$(s)
End Sub

Public Function RPad(s As String, i As Long) As String
    ' Right pads a string.  If string is already too long, it is NOT truncated.
    If Len(RTrim$(s)) > i Then
        RPad = s
    Else
        RPad = Left$(s & Space$(i), i)
    End If
End Function

Public Function AgeString(DOB As Variant, TheDate As Variant) As String
    Dim Years As Long
    Dim Months As Long
    Dim YrsDbl As Double
    '
    If IsNull(DOB) Or IsNull(TheDate) Then
        AgeString = ""
        Exit Function
    End If
    If VarType(DOB) <> vbDate Or VarType(TheDate) <> vbDate Then
        AgeString = ""
        Exit Function
    End If
    '
    YrsDbl = CDbl((TheDate - DOB) / 365)
    Years = Int(YrsDbl)
    Months = Int((YrsDbl - CDbl(Years)) * 12)
    '
    AgeString = Format$(Years) & "y " & Format$(Months) & "m"
End Function

Public Function AgeValue(DOB As Variant, TheDate As Variant) As Double
    Dim Years As Long
    Dim Months As Long
    Dim YrsDbl As Double
    '
    If IsNull(DOB) Or IsNull(TheDate) Then
        AgeValue = 0
        Exit Function
    End If
    If VarType(DOB) <> vbDate Or VarType(TheDate) <> vbDate Then
        AgeValue = 0
        Exit Function
    End If
    '
    AgeValue = CDbl((TheDate - DOB) / 365)
End Function

Public Function bFileIsFree(sFileSpec As String) As Boolean
    ' The file MUST exist or it will appear as a locked file.
    ' This is used to determine if some other process has the file open.
    Dim iFleNum As Long
    '
    On Error Resume Next
    iFleNum = FreeFile
    Open sFileSpec For Binary Lock Read Write As iFleNum
    Close iFleNum
    bFileIsFree = Err.Number = 0
End Function

Public Function FirstWord(s As String) As String
    Dim s2 As String
    Dim i As Long
    '
    s2 = Trim$(s)
    i = InStr(s2, " ")
    If i = 0 Then
        FirstWord = s2
    Else
        FirstWord = Left$(s2, i - 1)
    End If
End Function

Public Sub PutNameInCaption(frm As Form)
    frm.Caption = frm.Caption & "   (" & frm.Name & ")"
End Sub

Public Property Let StringToAsciiFile(sFileSpec As String, sStr As String)
    ' If file exists, this will fail.
    Dim iFle As Long
    '
    If bFileExists(sFileSpec) Then Exit Property
    iFle = FreeFile
    On Error Resume Next
    Open sFileSpec For Output As iFle
    If Err <> 0 Then Close iFle: Exit Property
    On Error GoTo 0
    Print #iFle, sStr;
    Close iFle
End Property

Public Function AsciiFileToString(sFileSpec As String) As String
    Dim iFle As Long
    '
    If Not bFileExists(sFileSpec) Then Exit Function
    iFle = FreeFile
    On Error Resume Next
    Open sFileSpec For Binary As iFle
    If Err <> 0 Then Close iFle: Exit Function
    On Error GoTo 0
    If Len(iFle) = 0 Then Close iFle: Exit Function
    '
    ' For variable length strings, the number of bytes read equals the number of characters already in the string.
    AsciiFileToString = Space(LOF(iFle))
    Get iFle, 1, AsciiFileToString
    Close iFle
End Function

Public Function BinaryFileSearch(sFileSpec As String, sSearchString As String, Optional bCaseSensitive As Boolean = True, _
                                 Optional lStartPosition As Long = 1, Optional lFoundPosition As Long, _
                                 Optional lFileHandleToUse As Long = 0) As Boolean
    ' Returns true if sSearchString is found, else false.
    ' sSearchString can be no longer than 128.
    ' This will work even if Excel has the file open.
    ' The lFoundPosition is a return argument.
    '    It returns the latest position before lStartPosition (if there isn't one after lStartPosition) or
    '    it returns the earliest position after lStartPosition.
    Dim iFle As Long
    Dim FileData As String
    Dim FilePointer As Long
    Dim FileLength As Long
    Dim sFind As String
    Dim iPos As Long
    '
    If Len(sSearchString) > 128 Then
        Error 1234
        Exit Function
    End If
    '
    If lFileHandleToUse = 0 Then
        If Not bFileExists(sFileSpec) Then Exit Function
        iFle = FreeFile
        On Error Resume Next
        Open sFileSpec For Binary As iFle
        If Err <> 0 Then Close iFle: Exit Function
        On Error GoTo 0
        If Len(iFle) = 0 Then Close iFle: Exit Function
    Else
        iFle = lFileHandleToUse ' The file MUST be opened BINARY for this to work.
    End If
    '
    If bCaseSensitive Then
        sFind = sSearchString
    Else
        sFind = LCase$(sSearchString)
    End If
    FileData = Space(1024)
    FileLength = LOF(iFle)
    FilePointer = lStartPosition
    Do
        If FilePointer > FileLength Then Exit Do
        Get iFle, FilePointer, FileData
        If Not bCaseSensitive Then FileData = LCase$(FileData)
        iPos = InStr(FileData, sFind)
        If iPos <> 0 Then
            lFoundPosition = FilePointer + iPos - 1
            If lFoundPosition >= lStartPosition Then
                BinaryFileSearch = True
                Exit Do
            End If
        End If
        FilePointer = ((FilePointer + 1024) - Len(sFind)) + 1
    Loop
    If lFileHandleToUse = 0 Then Close iFle
End Function

Public Function NoSpaces(sFullString As String) As String
    NoSpaces = Replace$(sFullString, " ", "")
End Function

Public Function NoSpacesOrFunnyStuff(sFullString As String) As String
    Dim s As String
    '
    ' Following aren't valid in a filename: / ? < > \ : * | "
    s = sFullString
    s = Replace$(s, " ", "")
    s = Replace$(s, "(", "")
    s = Replace$(s, ")", "")
    s = Replace$(s, Chr$(34), "")
    s = Replace$(s, "'", "")
    s = Replace$(s, "!", "")
    s = Replace$(s, "@", "")
    s = Replace$(s, "#", "")
    s = Replace$(s, "*", "")
    s = Replace$(s, "-", "")
    s = Replace$(s, "+", "")
    s = Replace$(s, ",", "")
    s = Replace$(s, ";", "")
    s = Replace$(s, ":", "")
    s = Replace$(s, "?", "")
    s = Replace$(s, ".", "")
    s = Replace$(s, "?", "")
    s = Replace$(s, "/", "")
    s = Replace$(s, "\", "")
    s = Replace$(s, "`", "")
    s = Replace$(s, "~", "")
    s = Replace$(s, "_", "")
    s = Replace$(s, "|", "")
    s = Replace$(s, "<", "")
    s = Replace$(s, ">", "")
    '
    NoSpacesOrFunnyStuff = s
End Function

Public Sub RemoveAllOccurrencesInString(sFullString As String, sMidStr As String)
    sFullString = Replace$(sFullString, sMidStr, "")
End Sub

Public Sub ReplaceAllOccurrencesInString(sFullString As String, sOldMidStr As String, sNewMidStr As String)
    sFullString = Replace$(sFullString, sOldMidStr, sNewMidStr)
End Sub

Public Function IsDimensioned(vArray As Variant) As Boolean
    Dim sa As SAFEARRAY
    Dim ppSA As Long
    Dim pSA As Long
    If IsArray(vArray) Then
        ' Get the pointer to the array inside the Variant structure
        '
        CopyMemory ppSA, ByVal VarPtr(vArray) + 8, 4
        CopyMemory pSA, ByVal ppSA, 4 'deref ppSA
        ' If we have a pointer then get the descriptor, else return false
        '
        If Not (pSA = 0) Then
            CopyMemory sa, ByVal pSA, LenB(sa)
            IsDimensioned = Not (sa.cDims = 0)
        Else
            IsDimensioned = False
        End If
    Else
        ' Not an array so cannot be dimensioned.
        IsDimensioned = False
    End If
End Function

Public Function SafeLeft(s As String, i As Long) As String
    On Error Resume Next
    SafeLeft = Left(s, i)
End Function

Public Function FormatRoman(v As Variant, Optional bZeroIsBlank As Boolean = False) As String
    Const r = "IVXLCDM"              ' roman symbols
    Dim i As Integer
    Dim s As String
    Dim P As Integer
    Dim d As Integer
    Dim n As Long
    '
    If VarType(v) = vbString Then If v = "" Then Exit Function ' If it's a null string, we shouldn't be trying to make a roman numeral.
    On Error Resume Next
    n = Int(Val(v))
    On Error GoTo 0
    If n = 0 Then
        If Not bZeroIsBlank Then FormatRoman = "0"
        Exit Function
    End If
    i = Abs(n)
    '
    For P = 1 To 5 Step 2
        d = i Mod 10
        i = i \ 10
        Select Case d ' Format a decimal digit
        Case 0 To 3: s = String(d, Mid(r, P, 1)) & s
        Case 4:      s = Mid(r, P, 2) & s
        Case 5 To 8: s = Mid(r, P + 1, 1) & String(d - 5, Mid(r, P, 1)) & s
        Case 9:      s = Mid(r, P, 1) & Mid(r, P + 2, 1) & s
        End Select
    Next P
    s = String(i, "M") & s ' Format thousands
    If n < 0 Then s = "-" & s ' Insert sign if negative (non-standard)
    FormatRoman = s
End Function

Public Function IsLoaded(FormName As String) As Boolean
    ' Does not have the side effect of needing to load the form just to see if it's loaded.
    Dim frm As Form
    For Each frm In Forms
        If frm.Name = FormName Then
            IsLoaded = True
            Exit Function
        End If
    Next frm
    IsLoaded = False
End Function

Public Function bCompiled() As Boolean
    On Error Resume Next
    Debug.Print 1 / 0
    bCompiled = Err = 0
End Function

Public Function bObjectHasScale(o As Object) As Boolean
    Dim l As Long
    On Error GoTo NoScale
    l = o.ScaleWidth
    bObjectHasScale = True
    Exit Function
NoScale:
    bObjectHasScale = False
    Exit Function
End Function

Public Function bHasContainer(o As Object) As Boolean
    Dim s As String
    On Error GoTo NoContainer
    s = o.Container.Name
    bHasContainer = True
    Exit Function
NoContainer:
    bHasContainer = False
    Exit Function
End Function

Public Function sYesNoFromYN(s As String) As String
    If UCase$(Left$(s, 1)) = "N" Then
        sYesNoFromYN = "No"
    Else
        sYesNoFromYN = "Yes"
    End If
End Function

Public Function sYNFromYesNo(s As String) As String
    If UCase$(Left$(s, 1)) = "N" Then
        sYNFromYesNo = "N"
    Else
        sYNFromYesNo = "Y"
    End If
End Function

Public Function bFromYN(s As String) As Boolean
    ' Y or y returns true.  All else returns false.
    bFromYN = UCase$(s) = "Y"
End Function

Public Function sYNFromBool(b As Boolean) As String
    ' Returns Y/N string based on boolean.
    sYNFromBool = IIf(b, "Y", "N")
End Function

Public Function sYesNoFromBool(b As Boolean) As String
    ' Returns Yes/No string based on boolean.
    sYesNoFromBool = IIf(b, "Yes", "No")
End Function

Public Function sYesBlankFromBool(b As Boolean) As String
    ' Returns Yes or null string based on boolean.
    sYesBlankFromBool = IIf(b, "Yes", "")
End Function

Public Function chkFromBool(b As Boolean) As Integer
    chkFromBool = IIf(b, vbChecked, vbUnchecked)
End Function

Public Function bFromChk(chk As CheckBox) As Boolean
    ' Returns whether or not a checkbox is checked.
    ' Greyed values are returned as true.
    bFromChk = chk.Value <> vbUnchecked
End Function

Public Function sYNFromChk(chk As CheckBox) As String
    ' Returns Y/N based on checkbox.
    sYNFromChk = sYNFromBool(bFromChk(chk))
End Function

Public Function chkFromYN(s As String) As Integer
    ' Returns value suitable for checkbox from Y/N string.
    chkFromYN = chkFromBool(bFromYN(s))
End Function

Public Function sPad(s As String, i As Integer) As String
    sPad = Left$(s & Space$(i), i)
End Function

Public Function sNumberCode(s As String) As String
    sNumberCode = Format$(Int(Val(s)), "0000000000")
End Function

Public Function bExists(fle As String) As Boolean
    Dim i As Long
    On Error GoTo FileExistsError
    ' If no error then something existed.
    i = GetAttr(fle)
    bExists = True
    Exit Function
FileExistsError:
    bExists = False
    Exit Function
End Function

Public Function bFileExists(fle As String) As Boolean
    On Error GoTo FileExistsError
    ' If no error then something existed.
    bFileExists = (GetAttr(fle) And vbDirectory) = 0
    Exit Function
FileExistsError:
    bFileExists = False
    Exit Function
End Function

Public Function bFolderExists(sDir As String) As Boolean
    Dim s As String
    s = sDir
    If Right$(s, 1) = "\" Then s = Left$(s, Len(s) - 1)
    On Error GoTo FileExistsError
    ' If no error then something existed.
    bFolderExists = ((GetAttr(s) And vbDirectory) = vbDirectory)
    Exit Function
FileExistsError:
    bFolderExists = False
    Exit Function
End Function

Public Sub sSwap(s1 As String, s2 As String)
    ' Swaps two strings.
    ' Static for speed because it might be used in sorts.
    Static sTemp As String
    sTemp = s1
    s1 = s2
    s2 = sTemp
End Sub

Public Sub lSwap(L1 As Long, L2 As Long)
    ' Swaps two long.
    ' Static for speed because it might be used in sorts.
    Static lTemp As Long
    lTemp = L1
    L1 = L2
    L2 = lTemp
End Sub

Public Sub AutoSelect(txt As TextBox)
    ' This procedure is used in the GotFocus event of a textbox.
    ' It selects all the text when the text box gets the focus.
    '
    ' AutoSelect txt...
    txt.SelStart = 0
    txt.SelLength = Len(txt.Text)
End Sub

Public Sub ReplaceCaption(obj As Object, s As String)
    ' This procedure replaces ??? in the caption of a control with the string.
    ' If no ??? is found, nothing is done.  If more than three ?s are found
    ' then the first three are replaced and the remainder are left alone.  This
    ' allows for multiple replacements in the same caption with multiple calls
    ' to this procedure.
    '
    ' This will work for labels and command buttons, and any other control
    ' with a Caption property.  It will also work on forms.  It does nothing
    ' if no caption property is found.
    Dim sq As String
    Dim i As Integer
    '
    On Error Resume Next
    sq = obj.Caption
    i = InStr(sq, "???")
    If i = 0 Then Exit Sub
    '
    obj.Caption = Left$(sq, i - 1) & s & Mid$(sq, i + 3)
End Sub

Public Sub ForSequentialFile(KeyAscii As Integer)
    ' Used only in KeyPress events.
    ' Allows only printable characters except for quotes.
    Select Case KeyAscii
    Case 8, 13, 32, 33, 35 To 126 ' These are OK.
    Case Else
        KeyAscii = 0
    End Select
End Sub

Public Sub MoneyOnly(KeyAscii As Integer)
    ' Used only in KeyPress events.
    ' Allows only ENTER, BACKSPACE, 0 thru 9, +, -, dot, comma, or $.
    Select Case KeyAscii
    Case 8, 13, 36, 43 To 46, 48 To 57 ' These are OK.
    Case Else
        KeyAscii = 0
    End Select
End Sub

Public Sub AlphaNumericUpper(KeyAscii As Integer)
    ' Used only in KeyPress events.
    KeyAscii = Asc(UCase$(Chr$(KeyAscii)))
    Select Case KeyAscii
    Case 8, 13, 48 To 57, 65 To 90 ' These are OK.
    Case Else
        KeyAscii = 0
    End Select
End Sub

Public Sub AlphaUpperOnly(KeyAscii As Integer)
    ' Used only in KeyPress events.
    KeyAscii = Asc(UCase$(Chr$(KeyAscii)))
    Select Case KeyAscii
    Case 8, 13, 65 To 90 ' These are OK.
    Case Else
        KeyAscii = 0
    End Select
End Sub

Public Sub UpperCase(KeyAscii As Integer)
    ' Makes a text box all uppercase.
    KeyAscii = Asc(UCase$(Chr$(KeyAscii)))
End Sub

Public Sub SelectAllListItems(lst As ListBox)
    ' Does nothing if multiselect is false.
    Dim i As Integer
    If lst.MultiSelect = 0 Then
        Exit Sub
    End If
    '
    For i = 0 To lst.ListCount - 1
        lst.Selected(i) = True
    Next i
End Sub

Public Sub DeselectSeparatorItems(lst As ListBox)
    ' The separator is assumed to be at least four "-" long, or longer.
    ' Does nothing if multiselect is false.
    Dim i As Integer
    If lst.MultiSelect = 0 Then
        Exit Sub
    End If
    '
    For i = 0 To lst.ListCount - 1
        If Left$(lst.List(i), 4) = "----" Then
            lst.Selected(i) = False
        End If
    Next i
End Sub

Public Sub DeselectAllListItems(lst As ListBox)
    ' Does nothing if multiselect is false.
    Dim i As Integer
    If lst.MultiSelect = 0 Then
        Exit Sub
    End If
    '
    For i = 0 To lst.ListCount - 1
        lst.Selected(i) = False
    Next i
End Sub

Public Function bNoListItemsSelected(lst As ListBox) As Boolean
    If lst.ListCount = 0 Then
        bNoListItemsSelected = True
        Exit Function
    End If
    bNoListItemsSelected = (lst.SelCount = 0)
End Function

Public Function bOnlyOneListItemSelected(lst As ListBox) As Boolean
    If lst.ListCount = 0 Then
        bOnlyOneListItemSelected = False
        Exit Function
    End If
    bOnlyOneListItemSelected = (lst.SelCount = 1)
End Function

Public Function bAllListItemsSelected(lst As ListBox) As Boolean
    ' Returns FALSE if there are no items.
    If lst.ListCount = 0 Then
        bAllListItemsSelected = False
        Exit Function
    End If
    bAllListItemsSelected = (lst.SelCount = lst.ListCount)
End Function

Public Property Let FrameAndChildrenEnabled(fra As Frame, bEnableStatus As Boolean)
    ' This enables/disables all child controls of a specific frame.
    Dim i As Integer
    Dim frm As Form
    '
    Set frm = fra.Parent
    For i = 0 To frm.Controls.Count - 1
        If bControlHasContainer(frm.Controls(i)) Then
            If frm.Controls(i).Container Is fra Then
                '
                ' Recursion to handle frames within frames.
                If TypeOf frm.Controls(i) Is Frame Then
                    FrameAndChildrenEnabled(frm.Controls(i)) = bEnableStatus
                Else
                    On Error Resume Next ' not all controls have an enabled property
                    frm.Controls(i).Enabled = bEnableStatus
                    If TypeOf frm.Controls(i) Is OptionButton Then ' Make sure Tabstop stays off for UCBED.
                        frm.Controls(i).TabStop = False
                    End If
                    On Error GoTo 0
                End If
            End If
        End If
    Next i
    fra.Enabled = bEnableStatus
End Property

Public Function bControlHasContainer(TheControl As Control) As Boolean
    '
    Dim TheContainer As Control
    On Error GoTo NoContainer
    Set TheContainer = TheControl.Container
    bControlHasContainer = True
    Exit Function
    '
NoContainer:
    bControlHasContainer = False
    Exit Function
    '
End Function

Public Function lTitleHeight(frm As Form) As Long
    ' Returns the number of twips between the top of a form and the scalewidth.
    ' ScaleMode must be twips.
    ' It is assumed that there is no bottom status bar (only a border).
    Dim lTop As Long
    lTop = (frm.Height - frm.ScaleHeight) ' This is top and bottom.
    lTop = lTop - lBorderWidth(frm) ' Subtract the bottom border.
    '
    lTitleHeight = lTop
End Function

Public Function lBorderWidth(frm As Form) As Long
    lBorderWidth = (frm.Width - frm.ScaleWidth) \ 2
End Function

Public Sub NumericOnly(KeyAscii As Integer)
    ' Used only in KeyPress events.
    ' Allows only ENTER, BACKSPACE, or numbers.
    Select Case KeyAscii
    Case 8, 13, 48 To 57 ' These are OK.
    Case Else
        KeyAscii = 0
    End Select
End Sub

Public Sub NumberOnly(KeyAscii As Integer)
    ' Used only in KeyPress events.
    ' Allows only ENTER, BACKSPACE, or number characters.
    ' This allows 0 thru 9, +, -, '.'.
    ' It is different from NumericOnly in that it allows
    ' these number related characters.
    Select Case KeyAscii
    Case 8, 13, 43, 45, 46, 48 To 57 ' These are OK.
    Case Else
        KeyAscii = 0
    End Select
End Sub

Public Function sUnFormatYYYYMMDD(sFormattedDate As String) As String
    ' Takes a formatted date and returns YYYYMMDD.
    Dim s As String
    s = sFormattedDate
    If Len(s) <> 10 Then s = sToday
    If Left$(sUserDateFormat, 1) = "m" Then
        sUnFormatYYYYMMDD = Right$(s, 4) & Left$(s, 2) & Mid$(s, 4, 2)
    Else
        sUnFormatYYYYMMDD = Right$(s, 4) & Mid$(s, 4, 2) & Left$(s, 2)
    End If
End Function

Public Function sToday() As String
    ' Returns today's date formatted for text box.
    sToday = sFormatDT(Date)
End Function

Public Function sFormatYYYYMMDD(strYYYYMMDD As String) As String
    ' This takes a YYYYMMDD date  and formats it to a
    ' mm/dd/yyyy or dd/mm/yyyy format as determined by Windows.
    '
    ' Returns today if the dt date is not a valid date.
    Dim s As String
    s = strYYYYMMDD
    If Len(s) <> 8 Then
        s = sUnFormatYYYYMMDD(sToday)
    End If
    If Left$(sUserDateFormat, 1) = "m" Then
        s = Mid$(s, 5, 2) & sDateSeparator & Right$(s, 2) & sDateSeparator & Left$(s, 4)
    Else
        s = Right$(s, 2) & sDateSeparator & Mid$(s, 5, 2) & sDateSeparator & Left$(s, 4)
    End If
    If IsDate(s) Then
        sFormatYYYYMMDD = s
    Else
        sFormatYYYYMMDD = sToday
    End If
End Function

Public Function sFormatDT(dt As Date) As String
    ' This takes a date data type and formats it to a
    ' mm/dd/yyyy or dd/mm/yyyy format as determined by Windows.
    '
    ' Returns today if the dt date is not a valid date.
    Dim dt2 As Date
    If IsDate(dt) Then
        dt2 = dt
    Else
        dt2 = Date
    End If
    sFormatDT = Format$(dt2, sUserDateFormat)
End Function

Public Property Get bDayBeforeMonth() As Boolean
    bDayBeforeMonth = Left$(sUserDateFormat, 1) = "d"
End Property

Public Property Get sUserDateFormat() As String
    ' Returns a string for use in Format$ that is either mm/dd/yyyy or dd/mm/yyyy.
    ' The Windows settings are examined.
    Dim iMonthPosition As Integer
    Dim iDayPosition As Integer
    Dim sUserShortDateFormat As String
    Static sTheFormat As String
    Static bUserDateFormatInitialized As Boolean
    '
    If bUserDateFormatInitialized Then
        sUserDateFormat = sTheFormat
        Exit Property
    End If
    '
    sUserShortDateFormat = GetWindowsINIString("intl", "sShortDate")
    '
    iMonthPosition = InStr(UCase$(sUserShortDateFormat), "M")
    iDayPosition = InStr(UCase$(sUserShortDateFormat), "D")
    '
    If iMonthPosition > iDayPosition Then
        sTheFormat = "dd" + sDateSeparator + "mm" + sDateSeparator + "yyyy"
    Else
        sTheFormat = "mm" + sDateSeparator + "dd" + sDateSeparator + "yyyy"
    End If
    '
    ' Set initialized flag.
    bUserDateFormatInitialized = True
    sUserDateFormat = sTheFormat
End Property

Public Property Get sDateSeparator() As String
    ' Returns the date separator to be used, such as / or -.
    ' The Windows settings are examined.
    Static sTheSeparator As String * 1
    Static bUserSeparatorInitialized As Boolean
    '
    If bUserSeparatorInitialized Then
        sDateSeparator = sTheSeparator
        Exit Property
    End If
    '
    ' Initialize date formating variables.
    sTheSeparator = GetWindowsINIString("intl", "sDate")
    If sTheSeparator = " " Then
        sTheSeparator = "/"
    End If
    '
    ' Set initialized flag.
    bUserSeparatorInitialized = True
    sDateSeparator = sTheSeparator
End Property

Public Function GetWindowsINIString(AppName As String, KeyName As String) As String
    ' This function returns a string out of the WIN.INI file.
    Dim ChrsReturned As Integer
    Dim Default As String
    Dim DataString As String
    Const DataSize = 300
    '
    If Len(AppName) = 0 Then
        GetWindowsINIString = ""
        Exit Function
    End If
    '
    Default = ""
    DataString = Space$(DataSize)
    ChrsReturned = GetProfileString(AppName, KeyName, Default, DataString, DataSize)
    '
    GetWindowsINIString = Left$(DataString, ChrsReturned)
End Function

Public Function sFormatPhone(s As String) As String
    Dim s2 As String
    s2 = s
    If s2 = String$(10, 0) Then s2 = Space$(10)
    Select Case Len(s2)
    Case 7
        sFormatPhone = "(   ) " & Left$(s2, 3) & "-" & Right$(s2, 4)
    Case 10
        sFormatPhone = "(" & Left$(s2, 3) & ") " & Mid$(s2, 4, 3) & "-" & Right$(s2, 4)
    Case Else
        sFormatPhone = "(   ) 000-0000"
    End Select
End Function

Public Function sUnFormatPhone(s As String) As String
    If Len(s) <> 14 Then
        sUnFormatPhone = "   0000000"
    Else
        sUnFormatPhone = Mid$(s, 2, 3) & Mid$(s, 7, 3) & Right$(s, 4)
    End If
End Function

Public Function sFormatSSNumber(s As String) As String
    Dim s2 As String
    s2 = s
    If s2 = String$(9, 0) Or Len(s2) <> 9 Then s2 = Space$(9)
    sFormatSSNumber = Left$(s2, 3) & "-" & Mid$(s2, 4, 2) & "-" & Right$(s2, 4)
End Function

Public Function sUnFormatSSNumber(s As String) As String
    If Len(s) <> 11 Then
        sUnFormatSSNumber = "000000000"
    Else
        sUnFormatSSNumber = Left$(s, 3) & Mid$(s, 5, 2) & Right$(s, 4)
    End If
End Function

Public Function sFormatMoney(c As Currency) As String
    sFormatMoney = Format$(c, "#,###,###,##0.00")
End Function

Public Function sFilter(sString As String, sAllowed As String) As String
    ' This filters all but the characters in sAllowed from the sString string.
    Dim sOut As String
    Dim s As String * 1
    Dim i As Integer
    '
    For i = 1 To Len(sString)
        s = Mid(sString, i, 1)
        If InStr(sAllowed, s) <> 0 Then sOut = sOut & s
    Next i
    sFilter = sOut
    '
End Function

Public Function sFilterNonAlphaNumeric(sString As String) As String
    ' Leaves upper and lower case in tact.
    Dim s As String
    s = "1234567890"
    s = s & "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
    s = s & "abcdefghijklmnopqrstuvwxyz"
    sFilterNonAlphaNumeric = sFilter(sString, s)
End Function

Public Function sFilterNonPrintable(sString As String) As String
    Dim i As Long
    Static sAllowed As String
    '
    If Len(sAllowed) = 0 Then
        For i = 32 To 126
            sAllowed = sAllowed & Chr$(i)
        Next i
    End If
    sFilterNonPrintable = sFilter(sString, sAllowed)
End Function

Public Function KillFolder(sFolderPath As String) As Boolean
    ' deltree, deletetree, killtree, just here so search will find it.
    ' Returns TRUE if successful, FALSE if failure.
    ' This may be recursive.  bRecursing is only for internal (recursive) use.
    ' If permission is denied, this function just fails.
    ' However, some sub-folders or files may still be deleted.
    ' It doesn't matter whether it's terminated with "\" or not.
    Dim sPath As String
    Dim sFile As String
    Dim sFldr As String
    Dim lError As Long
    '
    sPath = sFolderPath
    ' Remove any terminating backslash.
    If Right$(sPath, 1) = "\" Then sPath = Left$(sPath, Len(sPath) - 1)
    '
    ' Kill all the files in the folder.
    Do
        sFile = SafeDir(sPath & "\*.*", vbHidden + vbReadOnly + vbSystem)
        If Len(sFile) = 0 Then Exit Do
        On Error Resume Next
        SetAttr sPath & "\" & sFile, vbNormal
        lError = Err
        On Error GoTo 0
        If lError Then Exit Function
        On Error Resume Next
        Kill sPath & "\" & sFile
        lError = Err
        On Error GoTo 0
        If lError Then Exit Function
    Loop
    '
    ' Search for sub-folders.
    Do
        sFldr = SafeDir(sPath & "\*.*", vbDirectory)
        If Len(sFldr) = 0 Then Exit Do
        sFldr = Dir$ ' Skip "." folder.
        If Len(sFldr) = 0 Then Exit Do
        sFldr = Dir$ ' Skip ".." folder.
        If Len(sFldr) = 0 Then Exit Do
        If Not KillFolder(sPath & "\" & sFldr) Then Exit Function
    Loop
    '
    ' Kill the folder.
    On Error Resume Next
    RmDir sPath
    lError = Err
    On Error GoTo 0
    If lError Then Exit Function
    '
    ' Return, reporting success.
    KillFolder = True
End Function

Public Sub SafeKill(sFle As String)
    On Error Resume Next
    Kill sFle
    Exit Sub
End Sub

Public Sub SafeFileCopy(sSource As String, sDest As String)
    On Error Resume Next
    FileCopy sSource, sDest
    Exit Sub
End Sub

Public Sub HardKill(sFle As String)
    ' The file must be closed.
    ' Also, this does NOT work with wildcards.
    ' Note that the file is NOT killed with no error if this fails.
    Dim i As Long
    ' This just tries harder to kill the file.
    On Error Resume Next
    i = GetAttr(sFle)
    If Err.Number <> 0 Then Exit Sub ' Either nothing exists or the file is open.
    If ((GetAttr(sFle) And vbDirectory) = vbDirectory) Then Exit Sub ' Can't delete folders as files.
    SetAttr sFle, vbNormal
    Kill sFle
    If Err.Number = 0 Then Exit Sub
    '
    ' As a second attempt, just try 100 times.
    For i = 1 To 100
        Err.Clear
        Kill sFle
        If Err.Number = 0 Then Exit Sub
    Next i
End Sub

Public Sub Rename(sFleOld As String, sFleNew As String)
    ' This is just an attempt to deal with minor network hickups.
    Dim l As Long
    On Error Resume Next
    Do
        Name sFleOld As sFleNew
        If Err.Number = 0 Then Exit Sub
        Sleep 100
        l = l + 1
        If l > 30 Then ' 3 seconds.
            Error 75
            Exit Sub
        End If
    Loop
End Sub

Public Sub Do1000Events()
    Dim i As Integer
    For i = 1 To 10
        Do100Events
    Next i
End Sub

Public Sub Do100Events()
    Dim i As Integer
    For i = 1 To 100
        DoEvents
    Next i
End Sub

Public Sub Do10Events()
    DoEvents: DoEvents: DoEvents: DoEvents: DoEvents
    DoEvents: DoEvents: DoEvents: DoEvents: DoEvents
End Sub

Public Function sLeftToNull(s As String) As String
    Dim i As Integer
    i = InStr(s, Chr$(0))
    If i = 0 Then
        sLeftToNull = s
    Else
        sLeftToNull = Left$(s, i - 1)
    End If
End Function

Public Function sRandomString(iLength As Integer) As String
    Dim i As Integer
    Dim j As Integer
    Dim s As String
    Randomize
    Do Until j = iLength
        ' This returns an integer from 48 to 83.
        i = Int(36 * Rnd + 48)
        ' Skip over characters between 9 and A.
        If i > 57 Then i = i + 7
        ' Now, i is between 48 and 57 or 65 and 90.
        '                   "0"    "9"   "A"    "Z"
        s = s + Chr$(i)
        j = j + 1
    Loop
    sRandomString = s
End Function

Public Sub WaitForTermination(lProcessIdFromShell As Long)
    ' This procedure should be used with some caution.
    ' The program will not be able to refresh its forms and controls
    '   while waiting.  The best way to use this is to make sure that
    '   the program has nothing visible before calling this procedure.
    '
    ' The following command is the best way to use this procedure:
    '            WaitForTermination Shell(  sTheShellCommandString  )
    Const SYNCHRONIZE As Long = &H100000
    Const INFINITE As Long = &HFFFF
    Dim lProcessHwnd As Long
    If lProcessIdFromShell = 0 Then ' Make sure there is a process to wait on.
        Exit Sub
    End If
    lProcessHwnd = OpenProcess(SYNCHRONIZE, 0, lProcessIdFromShell)
    If lProcessHwnd = 0 Then ' Make sure we can open the process.
        Exit Sub
    End If
    ' Wait for process to terminate.
    WaitForSingleObject lProcessHwnd, INFINITE
    CloseHandle lProcessHwnd
End Sub

Public Function bFloppyIsInDrive()
    ' At present, this tests only drive A:.
    ' BE CAREFUL, this will reset any active use of the DIR$ function.
    On Error GoTo FloppyError
    Dim s As String
    s = SafeDir("a:\*.*")
    bFloppyIsInDrive = True
    Exit Function
FloppyError:
    bFloppyIsInDrive = False
    Exit Function
End Function

Public Function bCanCopyFileToDrive(sFile As String, TargetDriveLetter As String) As Boolean
    ' Be sure and put the path in the sFile if necessary.
    '
    ' Must be uppercase drive letter WITH colon.
    Dim FileList(0) As String
    FileList(0) = sFile
    bCanCopyFileToDrive = bCanCopyFilesToDrive(FileList(), TargetDriveLetter)
End Function

Public Function bCanCopyFilesToDrive(FileList() As String, TargetDriveLetter As String) As Boolean
    ' This function is specifically used to see if a set of files can fit on
    ' a floppy.  If the TargetDriveLetter$ is not "A" or "B" then it is assumed
    ' to be a hard disk and it is assumed that it will fit.
    '
    ' It is assumed that any existing files will be overwritten.
    ' It is also assumed that the drives will already have a ":" on them.
    '
    ' Be sure and put the path in the FileList files if necessary.
    '
    ' Must be uppercase drive letter WITH colon.
    Dim FreeClusters&, BytesPerCluster&, FileHandle%, ClustersRequired&, pFileList%
    Dim BytesInFile&, ClustersInFile&, ClustersRecovered&
    Dim i As Integer
    '
    If TargetDriveLetter$ <> "A:" And TargetDriveLetter$ <> "B:" Then
        bCanCopyFilesToDrive = True
        Exit Function
    End If
    '
    ' Get cluster size and available clusters on floppy.
    Dim lpRootPathName As String
    Dim lpSectorsPerCluster As Long
    Dim lpBytesPerSector As Long
    Dim lpNumberOfFreeClusters As Long
    Dim lpTotalNumberOfClusters As Long
    lpRootPathName = TargetDriveLetter$ & "\"
    GetDiskFreeSpace lpRootPathName, lpSectorsPerCluster, lpBytesPerSector, lpNumberOfFreeClusters, lpTotalNumberOfClusters
    '
    FreeClusters& = lpNumberOfFreeClusters
    BytesPerCluster& = lpBytesPerSector * lpSectorsPerCluster
    '
    FileHandle% = FreeFile
    '
    ' Calculate required target drive clusters.
    ClustersRequired& = 0
    For pFileList% = LBound(FileList$) To UBound(FileList$)
        '
        ' Buggy, file might be open and cause conflict.
        If bFileExists(FileList(pFileList%)) Then
            Open FileList(pFileList%) For Binary As FileHandle%
            BytesInFile& = LOF(FileHandle%) ' Source file.
            Close FileHandle%
        Else
            BytesInFile& = 0 ' Source file does not exist.
        End If
        '
        ClustersInFile& = (BytesInFile& + BytesPerCluster& - 1) \ BytesPerCluster& ' For target drive.
        ClustersRequired& = ClustersRequired& + ClustersInFile&
    Next pFileList%
    '
    ' Calculate target drive clusters that will be recaptured.
    ClustersRecovered& = 0
    For pFileList% = LBound(FileList$) To UBound(FileList$)
        ' Strip any path off the source file.
        Dim sFileOnly As String
        sFileOnly = sFileNameOnly(FileList$(pFileList%))
        '
        Open TargetDriveLetter$ & sFileOnly For Binary As FileHandle%
        BytesInFile& = LOF(FileHandle%) ' Source file.
        Close FileHandle%
        If BytesInFile& = 0 Then
            Kill TargetDriveLetter$ & sFileOnly
        Else
            ClustersInFile& = (BytesInFile& + BytesPerCluster& - 1) \ BytesPerCluster& ' For target drive.
            ClustersRecovered& = ClustersRecovered& + ClustersInFile&
        End If
    Next pFileList%
    '
    bCanCopyFilesToDrive = (FreeClusters& + ClustersRecovered&) >= ClustersRequired&
    '
End Function

Public Function sFileNameOnly(sFile As String) As String
    ' Strip any path off the source file.
    Dim i As Integer
    Dim s  As String
    s = sFile
    i = InStr(s, "\")
    Do While i <> 0
        s = Mid$(s, i + 1)
        i = InStr(s, "\")
    Loop
    sFileNameOnly = s
End Function

Public Function dtDateWithoutTime(dt As Date) As Date
    dtDateWithoutTime = Int(dt)
End Function

Public Function sDay(iDay As Integer) As String
    Select Case iDay
    Case vbSunday: sDay = "Sunday"
    Case vbMonday: sDay = "Monday"
    Case vbTuesday: sDay = "Tuesday"
    Case vbWednesday: sDay = "Wednesday"
    Case vbThursday: sDay = "Thursday"
    Case vbFriday: sDay = "Friday"
    Case vbSaturday: sDay = "Saturday"
    Case Else: sDay = ""
    End Select
End Function

Public Function dtLastDayOfMonthFromMonthYear(iMonth As Integer, iYear As Integer) As Date
    ' ByVal is used so as to not change the arguments for the caller.
    Dim iMo As Integer
    Dim iYr As Integer
    iMo = iMonth
    iYr = iYear
    '
    Dim dt As Date
    '
    ' Increment the month so the first day of the next month can be gotten.
    iMo = iMo + 1
    If iMo = 13 Then
        iMo = 1
        iYr = iYr + 1
    End If
    dt = dtFromDayMonthYear(1, iMo, iYr)
    ' Decriment the first day of the next month to get the last day of the month.
    dtLastDayOfMonthFromMonthYear = dt - 1
    '
End Function

Public Sub IncrementYYYYMMDDByOneMonth(sDate As String)
    ' Must be an 8 character YYYYMMDD date.
    Dim iMonth As Integer
    Dim iYear As Integer
    '
    If Len(sDate) <> 8 Then Exit Sub
    iMonth = Val(Mid$(sDate, 5, 2))
    iYear = Val(Left$(sDate, 4))
    iMonth = iMonth + 1 ' first of month three months in future.
    If iMonth > 12 Then
        iMonth = 1
        iYear = iYear + 1
    End If
    sDate = Format$(iYear, "0000") & Format$(iMonth, "00") & Right$(sDate, 2)
End Sub

Public Sub IncrementYYYYMMDDByOneDay(sDate As String)
    If Len(sDate) <> 8 Then Exit Sub
    sDate = sYYYYMMDDFromDT(dtFromYYYYMMDD(sDate) + 1)
End Sub

Public Sub DecrimentYYYYMMDDByOneDay(sDate As String)
    If Len(sDate) <> 8 Then Exit Sub
    sDate = sYYYYMMDDFromDT(dtFromYYYYMMDD(sDate) - 1)
End Sub

Public Function dtFromYYYYMMDD(s As String) As Date
    If Len(s) <> 8 Then Exit Function
    dtFromYYYYMMDD = DateSerial(Val(Left$(s, 4)), Val(Mid$(s, 5, 2)), Val(Right$(s, 2)))
End Function

Public Function sYYYYMMDDFromDT(dt As Date) As String
    sYYYYMMDDFromDT = Format$(dt, "YYYYMMDD")
End Function

Public Function sYYYYMMDDFromDayMonthYear(iDay As Integer, iMonth As Integer, iYear As Integer) As String
    sYYYYMMDDFromDayMonthYear = sYYYYMMDDFromDT(dtFromDayMonthYear(iDay, iMonth, iYear))
End Function

Public Function dtFromDayMonthYear(iDay As Integer, iMonth As Integer, iYear As Integer) As Date
    dtFromDayMonthYear = DateSerial(iYear, iMonth, iDay)
End Function

Public Function sPushYYYYMMDDToEndOfMonth(sYYYYMMDD As String) As String
    ' The DD doesn't matter to this function.  It is completely discarded.
    Dim iYear As Integer
    Dim iMonth As Integer
    Dim iDay As Integer
    Dim dt As Date
    If Len(sYYYYMMDD) <> 8 Then Exit Function
    iYear = Val(Left$(sYYYYMMDD, 4))
    iMonth = Val(Mid$(sYYYYMMDD, 5, 2))
    ' Push it to the first day of the NEXT month and then back up one day.
    iMonth = iMonth + 1
    If iMonth > 12 Then
        iYear = iYear + 1
        iMonth = 1
    End If
    iDay = 1
    dt = dtFromDayMonthYear(iDay, iMonth, iYear)
    dt = dt - 1
    sPushYYYYMMDDToEndOfMonth = sYYYYMMDDFromDT(dt)
End Function

Public Sub dtSwap(dt1 As Date, dt2 As Date)
    ' Swaps two dates.
    Dim dtTemp As Date
    dtTemp = dt1
    dt1 = dt2
    dt2 = dtTemp
End Sub

Public Function sFirstDate() As String
    sFirstDate = sFormatDT(dtFirstDate)
End Function

Public Function sLastDate() As String
    sLastDate = sFormatDT(dtLastDate)
End Function

Public Function sYYYYMMDDFirstDate()
    sYYYYMMDDFirstDate = sYYYYMMDDFromDT(dtFirstDate)
End Function

Public Function sYYYYMMDDLastDate()
    sYYYYMMDDLastDate = sYYYYMMDDFromDT(dtLastDate)
End Function

Public Function sFormatMoneyForCheck(c As Currency) As String
    sFormatMoneyForCheck = Format$(c, "\ \*\*$#,###,###,##0.00\*\*")
End Function

Public Function sWrittenAmount(cMoney As Currency) As String
    Dim s As String
    '
    Static Dollars(0 To 9) As String
    Static Teens(0 To 9) As String
    Static Tens(0 To 9) As String
    Static Thousands(0 To 6) As String
    Static bInitialized As Boolean
    '
    If Not bInitialized Then
        Dollars(0) = "":        Dollars(1) = " One":    Dollars(2) = " Two"
        Dollars(3) = " Three":  Dollars(4) = " Four":   Dollars(5) = " Five"
        Dollars(6) = " Six":    Dollars(7) = " Seven":  Dollars(8) = " Eight"
        Dollars(9) = " Nine"
        Teens(0) = " Ten":      Teens(1) = " Eleven":   Teens(2) = " Twelve"
        Teens(3) = " Thirteen": Teens(4) = " Fourteen": Teens(5) = " Fifteen"
        Teens(6) = " Sixteen":  Teens(7) = " Seventeen": Teens(8) = " Eighteen"
        Teens(9) = " Nineteen"
        Tens(0) = "":           Tens(1) = " Ten":       Tens(2) = " Twenty"
        Tens(3) = " Thirty":    Tens(4) = " Forty":     Tens(5) = " Fifty"
        Tens(6) = " Sixty":     Tens(7) = " Seventy":   Tens(8) = " Eighty"
        Tens(9) = " Ninety"
        Thousands(0) = "":      Thousands(1) = " Thousand":     Thousands(2) = " Million"
        Thousands(3) = " Billion": Thousands(4) = " Trillion":  Thousands(5) = " Quadrillion"
        Thousands(6) = " Quintillion" ' Don't we wish.
        bInitialized = True
    End If
    '
    Dim sWork As String ' This is the string that is built.
    Dim sTmp1 As String ' This is the one that is nibbled away at.
    Dim sTmp2 As String ' This is the nibbled piece being deciphered.
    Dim iDesc As Integer ' This is a group of three numbers (thousands, etc.)
    '
    sWork = "/100 Dollars"
    ' Round and make it an integer by multiplying by 100.
    sTmp1 = Format$(Int(cMoney * 100# + 0.5)) ' Round to cents.
    ' If it's less than ten cents then add some zeros.
    If Len(sTmp1) < 3 Then sTmp1 = Right$("00" + sTmp1, 3)
    ' Nibble the cents.
    sTmp2 = Right$(sTmp1, 2)
    sTmp1 = Left$(sTmp1, Len(sTmp1) - 2)
    ' Handle cents.
    If sTmp2 = "00" Then
        sWork = "NO" + sWork
    Else
        sWork = sTmp2 + sWork
    End If
    ' Cents separator.
    sWork = " & " + sWork
    ' Loop through and handle each series of three digits.
    For iDesc = 0 To 6
        ' Nibble three digits.
        Dim i1 As Integer
        i1 = Len(sTmp1) - 3
        If i1 < 0 Then i1 = 0
        sTmp2 = Right$(Space$(3) + sTmp1, 3)
        sTmp1 = Left$(sTmp1, i1)
        ' See if we're done.
        If Val(sTmp2) = 0 And Len(sTmp1) = 0 Then ' We're done.
            ' If there were no dollars then say zero.
            If iDesc = 0 Then sWork = " Zero" + sWork
            Exit For
        End If
        ' If it's the first group (001 to 999) or if it's non-zero, process it.
        If iDesc = 0 Or Val(sTmp2) <> 0 Then
            ' Add thousand, millions, etc.
            sWork = Thousands(iDesc) + sWork
            ' Add 1 thru 9 and handle teens and tens.
            If Mid$(sTmp2, 2, 1) = "1" Then
                sWork = Teens(Val(Right$(sTmp2, 1))) + sWork
            Else
                sWork = Dollars(Val(Mid$(sTmp2, 3, 1))) + sWork
                sWork = Tens(Val(Mid$(sTmp2, 2, 1))) + sWork
            End If
            ' Add hundreds.
            If Val(Left$(sTmp2, 1)) <> 0 Then sWork = " Hundred" + sWork
            sWork = Dollars(Val(Left$(sTmp2, 1))) + sWork
        End If
    Next iDesc
    '
    sWrittenAmount = " ****" + Mid$(sWork, 2)
End Function

Public Function bInRange(Q, iLow As Integer, iHigh As Integer) As Boolean
    If IsNull(Q) Then
        bInRange = False
    Else
        If Q >= iLow And Q <= iHigh Then
            bInRange = True
        Else
            bInRange = False
        End If
    End If
End Function





