Attribute VB_Name = "modAllPurposeFolders"
Option Explicit
'
' The following must always have their terminating backslash.
Public PatientsFolder As String ' Stored in database in single record of PathToPatientFiles table.  Be sure this ALWAYS has the terminating back-slash!!!
Public FormsFolder As String
Public SMPlayerFolder As String
Public MLSViewerFolder As String
'
Private Declare Function SHGetSpecialFolderLocation Lib "shell32" (ByVal hWndOwner As Long, ByVal nFolder As Long, pidl As Long) As Long
Private Declare Function SHGetPathFromIDList Lib "shell32" (ByVal pidList As Long, ByVal lpBuffer As String) As Long
Private Declare Sub CoTaskMemFree Lib "ole32.dll" (ByVal pv As Long)
Private Declare Function GetTempPath Lib "kernel32" Alias "GetTempPathA" (ByVal nBufferLength As Long, ByVal lpBuffer As String) As Long
Private Declare Function GetWindowsDirectory Lib "kernel32" Alias "GetWindowsDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long
'
' SHGetSpecialFolderLocation: Caller should use SHGetMalloc to obtain an allocator that can free the pidl
' A COMPLETE list of the CSIDL constants is in comments at bottom of this module.
Public Enum CSIDL_CODE
    CSIDL_DESKTOP = &H0&                 ' <desktop>
    CSIDL_DESKTOPDIRECTORY = &H10&       ' <user name>\Desktop
    CSIDL_APPDATA = &H1A&                ' <user name>\Application Data
    CSIDL_LOCAL_APPDATA = &H1C&          ' <user name>\Local Settings\Application Data (non roaming)
    CSIDL_SYSTEM = &H25&                 ' GetSystemDirectory()
End Enum
#If False Then ' Intellisense fix.
    Public CSIDL_DESKTOP
    Public CSIDL_DESKTOPDIRECTORY
    Public CSIDL_APPDATA
    Public CSIDL_LOCAL_APPDATA
    Public CSIDL_SYSTEM
#End If
'
'    CSIDL_DESKTOP = &H0&                 ' <desktop>
'    CSIDL_INTERNET = &H1&                ' Internet Explorer (icon on desktop)
'    CSIDL_PROGRAMS = &H2&                ' Start Menu\Programs
'    CSIDL_CONTROLS = &H3&                ' My Computer\Control Panel
'    CSIDL_PRINTERS = &H4&                ' My Computer\Printers
'    CSIDL_PERSONAL = &H5&                ' My Documents
'    CSIDL_FAVORITES = &H6&               ' <user name>\Favorites
'    CSIDL_STARTUP = &H7&                 ' Start Menu\Programs\Startup
'    CSIDL_RECENT = &H8&                  ' <user name>\Recent
'    CSIDL_SENDTO = &H9&                  ' <user name>\SendTo
'    CSIDL_BITBUCKET = &HA&               ' <desktop>\Recycle Bin
'    CSIDL_STARTMENU = &HB&               ' <user name>\Start Menu
'    CSIDL_MYDOCUMENTS = &HC&             ' logical "My Documents" desktop icon
'    CSIDL_MYMUSIC = &HD&                 ' "My Music" folder
'    CSIDL_MYVIDEO = &HE&                 ' "My Videos" folder
'    CSIDL_DESKTOPDIRECTORY = &H10&       ' <user name>\Desktop
'    CSIDL_DRIVES = &H11&                 ' My Computer
'    CSIDL_NETWORK = &H12&                ' Network Neighborhood (My Network Places)
'    CSIDL_NETHOOD = &H13&                ' <user name>\nethood
'    CSIDL_FONTS = &H14&                  ' windows\fonts
'    CSIDL_TEMPLATES = &H15&
'    CSIDL_COMMON_STARTMENU = &H16&       ' All Users\Start Menu
'    CSIDL_COMMON_PROGRAMS = &H17&        ' All Users\Start Menu\Programs
'    CSIDL_COMMON_STARTUP = &H18&         ' All Users\Startup
'    CSIDL_COMMON_DESKTOPDIRECTORY = &H19& ' All Users\Desktop
'    CSIDL_APPDATA = &H1A&                ' <user name>\Application Data
'    CSIDL_PRINTHOOD = &H1B&              ' <user name>\PrintHood
'    CSIDL_LOCAL_APPDATA = &H1C&          ' <user name>\Local Settings\Application Data (non roaming)
'    CSIDL_ALTSTARTUP = &H1D&             ' non localized startup
'    CSIDL_COMMON_ALTSTARTUP = &H1E&      ' non localized common startup
'    CSIDL_COMMON_FAVORITES = &H1F&
'    CSIDL_INTERNET_CACHE = &H20&
'    CSIDL_COOKIES = &H21&
'    CSIDL_HISTORY = &H22&
'    CSIDL_COMMON_APPDATA = &H23&         ' All Users\Application Data
'    CSIDL_WINDOWS = &H24&                ' GetWindowsDirectory()
'    CSIDL_SYSTEM = &H25&                 ' GetSystemDirectory()
'    CSIDL_PROGRAM_FILES = &H26&          ' C:\Program Files
'    CSIDL_MYPICTURES = &H27&             ' C:\Program Files\My Pictures
'    CSIDL_PROFILE = &H28&                ' USERPROFILE
'    CSIDL_SYSTEMX86 = &H29&              ' x86 system directory on RISC
'    CSIDL_PROGRAM_FILESX86 = &H2A&       ' x86 C:\Program Files on RISC
'    CSIDL_PROGRAM_FILES_COMMON = &H2B&   ' C:\Program Files\Common
'    CSIDL_PROGRAM_FILES_COMMONX86 = &H2C& ' x86 Program Files\Common on RISC
'    CSIDL_COMMON_TEMPLATES = &H2D&       ' All Users\Templates
'    CSIDL_COMMON_DOCUMENTS = &H2E&       ' All Users\Documents
'    CSIDL_COMMON_ADMINTOOLS = &H2F&      ' All Users\Start Menu\Programs\Administrative Tools
'    CSIDL_ADMINTOOLS = &H30&             ' <user name>\Start Menu\Programs\Administrative Tools
'    CSIDL_CONNECTIONS = &H31&            ' Network and Dial-up Connections
'    CSIDL_COMMON_MUSIC = &H35&           ' All Users\My Music
'    CSIDL_COMMON_PICTURES = &H36&        ' All Users\My Pictures
'    CSIDL_COMMON_VIDEO = &H37&           ' All Users\My Video
'    CSIDL_RESOURCES = &H38&              ' Resource Direcotry
'    CSIDL_RESOURCES_LOCALIZED = &H39&    ' Localized Resource Direcotry
'    CSIDL_COMMON_OEM_LINKS = &H3A&       ' Links to All Users OEM specific apps
'    CSIDL_CDBURN_AREA = &H3B&            ' USERPROFILE\Local Settings\Application Data\Microsoft\CD Burning
'    CSIDL_COMPUTERSNEARME = &H3D&        ' Computers Near Me (computered from Workgroup membership)
'
'    CSIDL_FLAG_CREATE = &H8000&          ' combine with CSIDL_ value to force folder creation in SHGetFolderPath()
'    CSIDL_FLAG_DONT_VERIFY = &H4000&     ' combine with CSIDL_ value to return an unverified folder path
'    CSIDL_FLAG_NO_ALIAS = &H1000&        ' combine with CSIDL_ value to insure non-alias versions of the pidl
'    CSIDL_FLAG_PER_USER_INIT = &H800&    ' combine with CSIDL_ value to indicate per-user init (eg. upgrade)
'    CSIDL_FLAG_MASK = &HFF00&            ' mask for all possible flag values
'

Public Function AppPath() As String
    Dim s As String
    Dim iFle As Long
    Static TheAppPath As String
    '
    If Len(TheAppPath) <> 0 Then
        AppPath = TheAppPath
        Exit Function
    End If
    '
    ' Always includes terminating backslash.
    If Not bCompiled Then ' Just back up one folder and we should find the database.
        TheAppPath = App.Path
        TheAppPath = Left$(TheAppPath, InStrRev(TheAppPath, "\"))
    Else
        If Not bFileExists(App.Path & "\" & "PatientsAndServicesDatabase.ini") Then
            TheAppPath = App.Path & "\"
        Else
            iFle = FreeFile
            Open App.Path & "\" & "PatientsAndServicesDatabase.ini" For Input As iFle
            Do While Not EOF(iFle)
                Line Input #iFle, s
                If LCase$(Left$(s, 13)) = "databasepath:" Then
                    Exit Do
                Else
                    s = ""
                End If
            Loop
            s = Trim$(Mid$(s, 14))
            If Len(s) = 0 Then
                TheAppPath = App.Path & "\"
            Else
                If Right$(s, 1) <> "\" Then s = s & "\"
                If bFolderExists(s) Then
                    TheAppPath = s
                Else
                    TheAppPath = App.Path & "\"
                End If
            End If
            Close iFle
        End If
    End If
    AppPath = TheAppPath
End Function

Public Function DesktopFolder() As String
    ' Always include terminating backslash.
    DesktopFolder = ApiSpecialFolder(CSIDL_DESKTOPDIRECTORY)
End Function

Public Function ApiSpecialFolder(ByVal CSIDL As CSIDL_CODE) As String
    ' Always include terminating backslash.
    Dim s As String
    Dim Result As Long
    Dim ppidl As Long
    Dim i As Long
    '
    s = Space(260)
    '
    Result = SHGetSpecialFolderLocation(0, CSIDL, ppidl)
    If Result = 0 Then
        Result = SHGetPathFromIDList(ppidl, s)
        If Result Then
            i = InStr(s, Chr$(0)) ' Find first Null byte
            If i > 0 Then s = Left$(s, i - 1)
            s = Trim$(s)
            If Right$(s, 1) <> "\" Then s = s & "\"
            ApiSpecialFolder = s
        End If
        CoTaskMemFree ppidl
    Else
        ApiSpecialFolder = ""
    End If
End Function

Public Function WindowsOsFolder() As String
    ' Puts terminating backslash on.
    ' Returns "" if there's a problem.
    Dim s As String
    s = Space$(100)
    '
    If GetWindowsDirectory(s, 100) > 0 Then
        s = sLeftToNull(s)
        If Right$(s, 1) <> "\" Then s = s & "\"
        WindowsOsFolder = s
    Else
        WindowsOsFolder = ""
    End If
End Function

Public Function WindowsTempPath()
    ' There is also a database TempFolder function.
    Dim s As String
    Const MAX_PATH = 1024 ' Maximum long filename path length
    '
    s = Space$(MAX_PATH)
    GetTempPath MAX_PATH, s
    s = Left$(s, InStr(s, vbNullChar) - 1)
    If Right$(s, 1) <> "\" Then s = s & "\"
    WindowsTempPath = s
End Function

Public Function CustomTemplatesFolder()
    ' Always has terminating backslash.
    Dim s As String
    '
    s = AppPath & "CustomTemplates"
    If Not bFolderExists(s) Then MkDir s
    CustomTemplatesFolder = s & "\"
End Function

Public Function TempFolder() As String
    ' Always has terminating backslash.
    Dim s As String
    '
    s = AppPath & "Temp"
    If Not bFolderExists(s) Then MkDir s
    TempFolder = s & "\"
End Function
