Attribute VB_Name = "modAllPurposeNumbers"
'
' ****************************************************************
' ****************************************************************
' ****************************************************************
' This program is free software: you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' version 3 as published my the Free Software Foundation:
' http://www.gnu.org/licenses/gpl.html
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' This software was originally written by Elroy Sullivan, PhD in
' cooperation with Shriners Hospitals for Children, Houston.
' Dr. Sullivan can be reached at elroysullivan@gmail.com.
' ****************************************************************
' ****************************************************************
' ****************************************************************
'
'
'*****************************************************
'*****************************************************
' Developed by Elroy Sullivan, PhD
' Contact me at elroysullivan@gmail.com
' or (832) 865-0001
'*****************************************************
'*****************************************************
'
Option Explicit
'
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (ByRef Destination As Any, ByRef Source As Any, ByVal numbytes As Long)
'

Public Function FormatNumEx(d As Double, decimals As Long) As String
    If d = Int(d) Then
        FormatNumEx = Format$(d, "#")
    Else
        FormatNumEx = Format$(d, "#0." & String$(decimals, "0"))
    End If
End Function

Public Sub lInc(l As Long)
    l = l + 1
End Sub

Public Function ShiftBits(ByVal Value As Long, BitsToShift As Integer) As Long
    ' Positive shifts left (higher order).  Negative shifts right (lower order).
    Dim i As Long
    Dim c As Long
    '
    If (BitsToShift > 0) Then ' Positive shifts left.
        For i = 1 To BitsToShift
            ' Protect from (mask out) overflow (high order) and sign bit.
            c = Value And &HC0000000
            Value = Value And &H3FFFFFFF
            ' Do shift.
            Value = Value * &H2
            ' Handle any sign bit (it wraps).
            If c And &H80000000 Then Value = Value Or &H1
            ' Handle any overflow bit (it goes to sign bit).
            If c And &H40000000 Then
                Value = Value Or &H80000000 ' Sign bit on.
            Else
                Value = Value And &H7FFFFFFF ' Sign bit off.
            End If
        Next i
    Else ' Negative shifts right.
        For i = BitsToShift To -1
            ' Protect from (mask out) underflow (low order) and sign bit.
            c = Value And &H80000001
            Value = Value And &H7FFFFFFF
            ' Do shift.
            Value = Value \ &H2
            ' Handle any underflow bit (it goes to sign bit).
            If c And &H1 Then Value = Value Or &H80000000
            ' Handle any sign bit (it goes to high order non-sign bit).
            If c And &H80000000 Then
                Value = Value Or &H40000000 ' High order bit on.
            Else
                Value = Value And &HBFFFFFFF ' High order bit off.
            End If
        Next i
    End If
    ShiftBits = Value
End Function

Public Function Long2Binary(l As Long) As String
    Dim s As String
    '
    ' The sign bit is a bit trickier.
    s = s & Format$(Abs((l And &H80000000) = &H80000000))
    ' All others, just check the bit.
    s = s & Format$(Abs((l And &H40000000) <> 0))
    s = s & Format$(Abs((l And &H20000000) <> 0))
    s = s & Format$(Abs((l And &H10000000) <> 0))
    s = s & Format$(Abs((l And &H8000000) <> 0))
    s = s & Format$(Abs((l And &H4000000) <> 0))
    s = s & Format$(Abs((l And &H2000000) <> 0))
    s = s & Format$(Abs((l And &H1000000) <> 0))
    s = s & Format$(Abs((l And &H800000) <> 0))
    s = s & Format$(Abs((l And &H400000) <> 0))
    s = s & Format$(Abs((l And &H200000) <> 0))
    s = s & Format$(Abs((l And &H100000) <> 0))
    s = s & Format$(Abs((l And &H80000) <> 0))
    s = s & Format$(Abs((l And &H40000) <> 0))
    s = s & Format$(Abs((l And &H20000) <> 0))
    s = s & Format$(Abs((l And &H10000) <> 0))
    s = s & Format$(Abs((l And &H8000) <> 0))
    s = s & Format$(Abs((l And &H4000) <> 0))
    s = s & Format$(Abs((l And &H2000) <> 0))
    s = s & Format$(Abs((l And &H1000) <> 0))
    s = s & Format$(Abs((l And &H800) <> 0))
    s = s & Format$(Abs((l And &H400) <> 0))
    s = s & Format$(Abs((l And &H200) <> 0))
    s = s & Format$(Abs((l And &H100) <> 0))
    s = s & Format$(Abs((l And &H80) <> 0))
    s = s & Format$(Abs((l And &H40) <> 0))
    s = s & Format$(Abs((l And &H20) <> 0))
    s = s & Format$(Abs((l And &H10) <> 0))
    s = s & Format$(Abs((l And &H8) <> 0))
    s = s & Format$(Abs((l And &H4) <> 0))
    s = s & Format$(Abs((l And &H2) <> 0))
    s = s & Format$(Abs((l And &H1) <> 0))
    Long2Binary = s
End Function

Public Function Byte2Binary(bb As Byte) As String
    Dim s As String
    '
    s = s & Format$(Abs((bb And 128) <> 0))
    s = s & Format$(Abs((bb And 64) <> 0))
    s = s & Format$(Abs((bb And 32) <> 0))
    s = s & Format$(Abs((bb And 16) <> 0))
    s = s & Format$(Abs((bb And 8) <> 0))
    s = s & Format$(Abs((bb And 4) <> 0))
    s = s & Format$(Abs((bb And 2) <> 0))
    s = s & Format$(Abs((bb And 1) <> 0))
    Byte2Binary = s
End Function

Public Function Dec2Bin(mynum As Long) As String
    Dim loopcounter As Integer
    '
    Do
        If (mynum And 2 ^ loopcounter) = 2 ^ loopcounter Then
            Dec2Bin = "1" & Dec2Bin
        Else
            Dec2Bin = "0" & Dec2Bin
        End If
        loopcounter = loopcounter + 1
    Loop Until 2 ^ loopcounter > mynum
End Function

Public Function Bin2Dec(ByVal BinValue As String) As Long
    Dim lngValue As Long
    Dim X As Long
    Dim k As Long
    '
    k = Len(BinValue) ' will only work with 32 or fewer "bits"
    For X = k To 1 Step -1 ' work backwards down string
        If Mid$(BinValue, X, 1) = "1" Then
            If k - X > 30 Then ' bit 31 is the sign bit
                lngValue = lngValue Or -2147483648# ' avoid overflow error
            Else
                lngValue = lngValue + 2 ^ (k - X)
            End If
        End If
    Next X
    Bin2Dec = lngValue
End Function

Public Sub NoSign(bb As Byte)
    ' This treats a byte variable as a signed one byte integer
    ' and then removes the sign bit (to force to positive)
    ' if it's on.  It's similar to an INT() for an integer or long,
    ' except that it's a SUB rather than a function.
    '
    ' This is useful because C3D files use the sign bit as a flag
    ' and not a true sign bit in several cases.
    Select Case bb
    Case Is = 128: bb = 0
    Case Is > 128: bb = 256 - bb
    End Select ' Do nothing if < 128
End Sub

Public Function MaxByteVal(bb() As Byte) As Byte
    Dim bb2 As Byte
    Dim ptr As Long
    '
    For ptr = LBound(bb) To UBound(bb)
        If bb(ptr) > bb2 Then bb2 = bb(ptr)
    Next ptr
    MaxByteVal = bb2
End Function

Public Function HexStr(s As String) As String
    Dim i As Long
    Dim s2 As String
    '
    For i = 1 To Len(s)
        s2 = s2 & " " & Hex$(Asc(Mid$(s, i)))
    Next i
    HexStr = s2
End Function

Public Function IeeeFromDec(n As Single) As Single
    Dim bb1(0 To 3) As Byte
    Dim bb2(0 To 3) As Byte
    Dim n2 As Single
    '
    CopyMemory bb1(0), n, 4&
    bb2(0) = bb1(2)
    bb2(1) = bb1(3)
    bb2(2) = bb1(0)
    bb2(3) = bb1(1)
    If bb2(0) Or bb2(1) Or bb2(2) Or bb2(3) Then
        If bb2(3) = 0 Then
            bb2(3) = 255
        Else
            bb2(3) = bb2(3) - 1
        End If
    End If
    CopyMemory n2, bb2(0), 4&
    IeeeFromDec = n2
End Function
    
Public Function DecFromIeee(n As Single) As Single
    Dim bb1(0 To 3) As Byte
    Dim bb2(0 To 3) As Byte
    Dim n2 As Single
    '
    CopyMemory bb1(0), n, 4&
    bb2(0) = bb1(2)
    bb2(1) = bb1(3)
    bb2(2) = bb1(0)
    bb2(3) = bb1(1)
    If bb2(0) Or bb2(1) Or bb2(2) Or bb2(3) Then
        If bb2(1) = 255 Then
            bb2(1) = 0
        Else
            bb2(1) = bb2(1) + 1
        End If
    End If
    CopyMemory n2, bb2(0), 4&
    DecFromIeee = n2
End Function

Public Function LongFromUnsignedInt(i As Integer) As Long
    ' An integer is always considered signed in VB.  However,
    ' there may be cases where it should be treated as unsigned,
    ' especially if it were written to a file by another language.
    ' In these cases, the sign bit is not really a sign bit and
    ' should be considered the bit for 32768 (&h8000).  To allow
    ' VB to handle this situation, the bits are moved into a LONG
    ' which will always return a positive number from 0 to 65535
    ' (&h0000 to &hFFFF).
    '
    Dim bb(0 To 3) As Byte
    Dim l As Long
    '
    CopyMemory bb(0), i, 2&
    CopyMemory l, bb(0), 4&
    LongFromUnsignedInt = l
End Function

Public Function UnsignedIntFromLong(l As Long) As Integer
    ' An integer is always considered signed in VB.  However,
    ' there may be cases where it should be treated as unsigned,
    ' especially if it were written to a file by another language.
    ' In these cases, the sign bit is not really a sign bit and
    ' should be considered the bit for 32768 (&h8000).
    '
    ' Note that the two high bits of the long will be completely ignored,
    ' and this integer should not be used except for file I/O.
    ' Use LongFromUnsignedInt to get it back out.
    '
    Dim bb(0 To 3) As Byte
    Dim i As Integer
    '
    CopyMemory bb(0), l, 4&
    CopyMemory i, bb(0), 2&
    UnsignedIntFromLong = i
End Function


