Attribute VB_Name = "modApiCommonDialog"
'
' ****************************************************************
' ****************************************************************
' ****************************************************************
' This program is free software: you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' version 3 as published my the Free Software Foundation:
' http://www.gnu.org/licenses/gpl.html
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' This software was originally written by Elroy Sullivan, PhD in
' cooperation with Shriners Hospitals for Children, Houston.
' Dr. Sullivan can be reached at elroysullivan@gmail.com.
' ****************************************************************
' ****************************************************************
' ****************************************************************
'
Option Explicit
'
' These are used to get information about how the dialog went.
Public FileDialogSpec As String             ' Used for both Open & Save.
Public FileDialogFolder As String           ' Used for both Open & Save.
Public FileDialogName As String             ' Used for both Open & Save.
Public FileDialogSuccessful As Boolean      ' Used for both Open & Save.
Public FileDialogCount As Long              ' Used only for multi.
Public FileDialogNames() As String          ' Used only for multi (ONE based).
'
Private Const CCHDEVICENAME = 32
Private Const CCHFORMNAME = 32
Private Const DM_ORIENTATION = &H1&
Private Const DM_DUPLEX = &H1000&
Private Const GMEM_MOVEABLE = &H2
Private Const GMEM_ZEROINIT = &H40
'
Public Enum PrintDialogFlags
    PD_PRINTSETUP = &H40
    PD_DISABLEPRINTTOFILE = &H80000
End Enum
#If False Then ' Intellisense fix.
    Public PD_PRINTSETUP
    Public PD_DISABLEPRINTTOFILE
#End If
'
Private Declare Function SHGetSpecialFolderLocation Lib "shell32" (ByVal hWndOwner As Long, ByVal nFolder As Long, pidl As Long) As Long
Private Declare Function SHGetPathFromIDList Lib "shell32" (ByVal pidList As Long, ByVal lpBuffer As String) As Long
Private Declare Function GetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameA" (pOpenfilename As OpenSaveType) As Long
Private Declare Function GetSaveFileName Lib "comdlg32.dll" Alias "GetSaveFileNameA" (pOpenfilename As OpenSaveType) As Long
Private Declare Function PrintDialog Lib "comdlg32.dll" Alias "PrintDlgA" (pPrintdlg As PrintDialogType) As Long
Private Declare Function PageSetupDlg Lib "comdlg32.dll" Alias "PageSetupDlgA" (pPagesetupdlg As PageSetupDlg) As Long
Private Declare Function ChooseFont Lib "comdlg32.dll" Alias "ChooseFontA" (pChoosefont As ChooseFont) As Long
Private Declare Function ChooseColor Lib "comdlg32.dll" Alias "ChooseColorA" (pChoosecolor As ChooseColor) As Long
'
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (hpvDest As Any, hpvSource As Any, ByVal cbCopy As Long)
Private Declare Function GlobalLock Lib "kernel32" (ByVal hMem As Long) As Long
Private Declare Function GlobalUnlock Lib "kernel32" (ByVal hMem As Long) As Long
Private Declare Function GlobalAlloc Lib "kernel32" (ByVal wFlags As Long, ByVal dwBytes As Long) As Long
Private Declare Function GlobalFree Lib "kernel32" (ByVal hMem As Long) As Long
'
Private Type POINTAPI
    X As Long
    Y As Long
End Type
'
Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type
'
Private Type OpenSaveType
    lStructSize As Long
    hWndOwner As Long
    hInstance As Long
    lpstrFilter As String
    lpstrCustomFilter As String
    nMaxCustFilter As Long
    nFilterIndex As Long
    lpstrFile As String
    nMaxFile As Long
    lpstrFileTitle As String
    nMaxFileTitle As Long
    lpstrInitialDir As String
    lpstrTitle As String
    flags As Long
    nFileOffset As Integer
    nFileExtension As Integer
    lpstrDefExt As String
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As String
End Type
'
Public Enum FileDialogFlags
    OFN_READONLY = &H1
    OFN_OVERWRITEPROMPT = &H2
    OFN_HIDEREADONLY = &H4
    OFN_NOCHANGEDIR = &H8
    OFN_SHOWHELP = &H10
    OFN_ENABLEHOOK = &H20
    OFN_ENABLETEMPLATE = &H40
    OFN_ENABLETEMPLATEHANDLE = &H80
    OFN_NOVALIDATE = &H100
    OFN_ALLOWMULTISELECT = &H200
    OFN_EXTENSIONDIFFERENT = &H400
    OFN_PATHMUSTEXIST = &H800
    OFN_FILEMUSTEXIST = &H1000
    OFN_CREATEPROMPT = &H2000
    OFN_SHAREAWARE = &H4000
    OFN_NOREADONLYRETURN = &H8000
    OFN_NOTESTFILECREATE = &H10000
    OFN_NONETWORKBUTTON = &H20000
    OFN_NOLONGNAMES = &H40000         '  force no long names for 4.x modules
    OFN_EXPLORER = &H80000            '  new look commdlg
    OFN_NODEREFERENCELINKS = &H100000
    OFN_LONGNAMES = &H200000          '  force long names for 3.x modules
End Enum
#If False Then ' Intellisense fix.
    Public OFN_READONLY
    Public OFN_OVERWRITEPROMPT
    Public OFN_HIDEREADONLY
    Public OFN_NOCHANGEDIR
    Public OFN_SHOWHELP
    Public OFN_ENABLEHOOK
    Public OFN_ENABLETEMPLATE
    Public OFN_ENABLETEMPLATEHANDLE
    Public OFN_NOVALIDATE
    Public OFN_ALLOWMULTISELECT
    Public OFN_EXTENSIONDIFFERENT
    Public OFN_PATHMUSTEXIST
    Public OFN_FILEMUSTEXIST
    Public OFN_CREATEPROMPT
    Public OFN_SHAREAWARE
    Public OFN_NOREADONLYRETURN
    Public OFN_NOTESTFILECREATE
    Public OFN_NONETWORKBUTTON
    Public OFN_NOLONGNAMES
    Public OFN_EXPLORER
    Public OFN_NODEREFERENCELINKS
    Public OFN_LONGNAMES
#End If
'
Private Type PrintDialogType
    lStructSize As Long
    hWndOwner As Long
    hDevMode As Long
    hDevNames As Long
    hDC As Long
    flags As Long
    nFromPage As Integer
    nToPage As Integer
    nMinPage As Integer
    nMaxPage As Integer
    nCopies As Integer
    hInstance As Long
    lCustData As Long
    lpfnPrintHook As Long
    lpfnSetupHook As Long
    lpPrintTemplateName As String
    lpSetupTemplateName As String
    hPrintTemplate As Long
    hSetupTemplate As Long
End Type
'
Private Type PageSetupDlg
    lStructSize As Long
    hWndOwner As Long
    hDevMode As Long
    hDevNames As Long
    flags As Long
    ptPaperSize As POINTAPI
    rtMinMargin As RECT
    rtMargin As RECT
    hInstance As Long
    lCustData As Long
    lpfnPageSetupHook As Long
    lpfnPagePaintHook As Long
    lpPageSetupTemplateName As String
    hPageSetupTemplate As Long
End Type
'
Private Type ChooseFont
    lStructSize As Long
    hWndOwner As Long           ' caller's window handle
    hDC As Long                 ' printer DC/IC or NULL
    lpLogFont As Long           ' ptr. to a LOGFONT struct
    iPointSize As Long          ' 10 * size in points of selected font
    flags As Long               ' enum. type flags
    rgbColors As Long           ' returned text color
    lCustData As Long           ' data passed to hook fn.
    lpfnHook As Long            ' ptr. to hook function
    lpTemplateName As String    ' custom template name
    hInstance As Long           ' instance handle of.EXE that contains cust. dlg. template must be LF_FACESIZE or bigger
    lpszStyle As String         ' return the style field here
    nFontType As Integer        ' same value reported to the EnumFonts call back with the extra FONTTYPE bits added
    MISSING_ALIGNMENT As Integer
    nSizeMin As Long            ' minimum pt size allowed &
    nSizeMax As Long            ' max pt size allowed if CF_LIMITSIZE is used
End Type
'
Private Type ChooseColor
    lStructSize As Long
    hWndOwner As Long
    hInstance As Long
    rgbResult As Long
    lpCustColors As String
    flags As Long
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As String
End Type
'
Private Type DeviceNamesType
    wDriverOffset As Integer
    wDeviceOffset As Integer
    wOutputOffset As Integer
    wDefault As Integer
    extra As String * 100
End Type
'
Private Type DeviceModeType
    dmDeviceName As String * CCHDEVICENAME
    dmSpecVersion As Integer
    dmDriverVersion As Integer
    dmSize As Integer
    dmDriverExtra As Integer
    dmFields As Long
    dmOrientation As Integer
    dmPaperSize As Integer
    dmPaperLength As Integer
    dmPaperWidth As Integer
    dmScale As Integer
    dmCopies As Integer
    dmDefaultSource As Integer
    dmPrintQuality As Integer
    dmColor As Integer
    dmDuplex As Integer
    dmYResolution As Integer
    dmTTOption As Integer
    dmCollate As Integer
    dmFormName As String * CCHFORMNAME
    dmUnusedPadding As Integer
    dmBitsPerPel As Integer
    dmPelsWidth As Long
    dmPelsHeight As Long
    dmDisplayFlags As Long
    dmDisplayFrequency As Long
End Type
'
' *****************************************************
' The following are for the BrowseForFolder procedures.
' *****************************************************
Private Const MAX_PATH = 260
Private Declare Function SHBrowseForFolder Lib "shell32" (lpBI As BrowseInfo) As Long
Private Declare Function lstrcat Lib "kernel32" Alias "lstrcatA" (ByVal lpString1 As String, ByVal lpString2 As String) As Long
Private Declare Sub CoTaskMemFree Lib "ole32" (ByVal pv As Long)
Private Declare Function lstrlenW Lib "kernel32" (ByVal lpString As Long) As Long ' Return length of string, excluding nulls.
'
Private Const CSIDL_NETWORK As Long = &H12
Private Const CSIDL_PRINTERS As Long = &H4
'
Private Const BIF_RETURNONLYFSDIRS As Long = &H1    ' For finding a folder to start document searching
Private Const BIF_DONTGOBELOWDOMAIN As Long = &H2   ' For starting the Find Computer
' Top of the dialog has 2 lines of text for BROWSEINFO.lpszTitle and one line if this flag is set.
' Passing the message BFFM_SETSTATUSTEXTA to the hwnd can set the rest of the text.  This is not used with
' BIF_USENEWUI and BROWSEINFO.lpszTitle gets all three lines of text.
Private Const BIF_STATUSTEXT As Long = &H4
Private Const BIF_RETURNFSANCESTORS As Long = &H8
Private Const BIF_EDITBOX As Long = &H10            ' Add an editbox to the dialog: SHELL 5.0 or later only!
Private Const BIF_VALIDATE As Long = &H20           ' Insist on valid result (or CANCEL)
Private Const BIF_NEWDIALOGSTYLE As Long = &H40     ' Use the new dialog layout with the ability to resize: SHELL 5.0 or later only!
Private Const BIF_USENEWUI As Long = (BIF_NEWDIALOGSTYLE Or BIF_EDITBOX) ' Won't work with BIF_RETURNONLYFSDIRS or BIF_BROWSEFORCOMPUTER.
Private Const BIF_BROWSEINCLUDEURLS As Long = &H80  ' Allow URLs to be displayed or entered (Requires BIF_USENEWUI): SHELL 5.0 or later only!
Private Const BIF_UAHINT As Long = &H100            ' Add a UA hint to the dialog, in place of the edit box. May not be combined with BIF_EDITBOX: SHELL 6.0 or later only!
Private Const BIF_NONEWFOLDERBUTTON As Long = &H200 ' Do not add the "New Folder" button to the dialog. Only applicable with BIF_NEWDIALOGSTYLE: SHELL 5.0 or later only!
Private Const BIF_BROWSEFORCOMPUTER As Long = &H1000 ' Browsing for Computers
Private Const BIF_BROWSEFORPRINTER As Long = &H2000 ' Browsing for Printers
Private Const BIF_BROWSEINCLUDEFILES As Long = &H4000 ' Browsing for Everything
Private Const BIF_SHAREABLE As Long = &H8000&       ' sharable resources displayed (remote shares, requires BIF_USENEWUI): SHELL 5.0 or later only!
'
Private Type BrowseInfo
   hOwner As Long
   pidlRoot As Long
   pszDisplayName As String   'return display name of item selected
   lpszTitle As String        'text to go in the banner over the tree
   ulFlags As Long            'flags that control the return stuff
   lpfn As Long
   lParam As Long             'extra info passed back in callbacks
   iImage As Long             'output var: where to return the Image index
End Type
'

Public Sub ShowOpenFileDialogMulti(hWndOwner As Long, FileFilter As String, Optional InitialFolder As String, Optional flags As FileDialogFlags = OFN_FILEMUSTEXIST + OFN_EXPLORER + OFN_LONGNAMES + OFN_PATHMUSTEXIST, Optional Title As String = "Open File")
    ' See "Public" variables for what is set upon return.
    '
    ' Example:
    '    ShowOpenFileDialog hWnd, "Access Databases (*.mdb, *.mde)" & Chr$(0) & "*.mdb; *.mde" & Chr$(0), "C:\"
    '    If FileDialogSuccessful = True Then
    '        MsgBox "You selected file: " & FileDialogSpec
    '    Else
    '        MsgBox "No file selected."
    '    End If
    Dim OpenFile As OpenSaveType
    Dim l As Long
    Dim s As String
    Dim i As Long
    Dim iCnt As Long
    '
    Erase FileDialogNames
    FileDialogCount = 0
    '
    flags = flags + OFN_ALLOWMULTISELECT
    '
    OpenFile.lStructSize = Len(OpenFile)
    OpenFile.hWndOwner = hWndOwner
    OpenFile.hInstance = App.hInstance
    OpenFile.lpstrFilter = FileFilter
    OpenFile.nFilterIndex = 1
    OpenFile.lpstrFile = String$(30000, 0) ' This should easily accomodate more than 100 files, if not 1000s.
    OpenFile.nMaxFile = Len(OpenFile.lpstrFile) - 1
    OpenFile.lpstrFileTitle = OpenFile.lpstrFile
    OpenFile.nMaxFileTitle = OpenFile.nMaxFile
    OpenFile.lpstrInitialDir = InitialFolder
    OpenFile.lpstrTitle = Title
    OpenFile.flags = flags
    '
    l = GetOpenFileName(OpenFile)
    If l = 0 Then
        FileDialogSpec = "none"
        FileDialogFolder = ""
        FileDialogName = ""
        FileDialogSuccessful = False
    Else
        s = Left$(OpenFile.lpstrFile, InStr(OpenFile.lpstrFile, String$(3, 0))) ' Include terminating Chr$(0).
        ' Count the nulls.
        iCnt = 0
        For i = 1 To Len(s)
            If Asc(Mid$(s, i, 1)) = 0 Then
                iCnt = iCnt + 1
            End If
        Next i
        '
        If iCnt = 1 Then ' It's a single file.
            FileDialogSpec = Trim$(sLeftToNull(s))
            FileDialogFolder = Left$(FileDialogSpec, InStrRev(FileDialogSpec, "\"))
            FileDialogName = Mid$(FileDialogSpec, InStrRev(FileDialogSpec, "\") + 1)
            FileDialogSuccessful = True
            FileDialogCount = 1
            ReDim FileDialogNames(1 To 1)
            FileDialogNames(1) = FileDialogName
        Else
            FileDialogCount = iCnt - 1 ' Must knock off the folder.
            ReDim FileDialogNames(1 To iCnt - 1)
            FileDialogName = "multi"
            FileDialogSpec = "multi"
            '
            FileDialogFolder = Trim$(sLeftToNull(s)) & "\"
            s = Mid$(s, InStr(s, Chr$(0)) + 1)
            iCnt = 0
            Do While Len(s) <> 0
                iCnt = iCnt + 1
                FileDialogNames(iCnt) = sLeftToNull(s)
                s = Mid$(s, InStr(s, Chr$(0)) + 1)
            Loop
            '
            FileDialogSuccessful = True
        End If
    End If
End Sub

Public Sub ShowOpenFileDialog(hWndOwner As Long, FileFilter As String, Optional InitialFolder As String, Optional flags As FileDialogFlags, Optional Title As String = "Open File")
    ' See "Public" variables for what is set upon return.
    '
    ' Example:
    '    ShowOpenFileDialog hWnd, "Access Databases (*.mdb, *.mde)" & Chr$(0) & "*.mdb; *.mde" & Chr$(0), "C:\"
    '    If FileDialogSuccessful = True Then
    '        MsgBox "You selected file: " & FileDialogSpec
    '    Else
    '        MsgBox "No file selected."
    '    End If
    Dim OpenFile As OpenSaveType
    Dim l As Long
    '
    OpenFile.lStructSize = Len(OpenFile)
    OpenFile.hWndOwner = hWndOwner
    OpenFile.hInstance = App.hInstance
    OpenFile.lpstrFilter = FileFilter
    OpenFile.nFilterIndex = 1
    OpenFile.lpstrFile = String(257, 0)
    OpenFile.nMaxFile = Len(OpenFile.lpstrFile) - 1
    OpenFile.lpstrFileTitle = OpenFile.lpstrFile
    OpenFile.nMaxFileTitle = OpenFile.nMaxFile
    OpenFile.lpstrInitialDir = InitialFolder
    OpenFile.lpstrTitle = Title
    OpenFile.flags = flags
    '
    l = GetOpenFileName(OpenFile)
    If l = 0 Then
        FileDialogSpec = "none"
        FileDialogFolder = ""
        FileDialogName = ""
        FileDialogSuccessful = False
    Else
        FileDialogSpec = Trim$(sLeftToNull(OpenFile.lpstrFile))
        FileDialogFolder = Left$(FileDialogSpec, InStrRev(FileDialogSpec, "\"))
        FileDialogName = Mid$(FileDialogSpec, InStrRev(FileDialogSpec, "\") + 1)
        FileDialogSuccessful = True
    End If
End Sub

Public Sub ShowSaveFileDialog(hWndOwner As Long, FileFilter As String, Optional InitialFolder As String, Optional flags As FileDialogFlags, Optional Title As String = "Save File")
    ' See "Public" variables for what is set upon return.
    Dim SaveFile As OpenSaveType
    Dim l As Long
    '
    SaveFile.lStructSize = Len(SaveFile)
    SaveFile.hWndOwner = hWndOwner
    SaveFile.hInstance = App.hInstance
    SaveFile.lpstrFilter = FileFilter
    SaveFile.nFilterIndex = 1
    SaveFile.lpstrFile = String(257, 0)
    SaveFile.nMaxFile = Len(SaveFile.lpstrFile) - 1
    SaveFile.lpstrFileTitle = SaveFile.lpstrFile
    SaveFile.nMaxFileTitle = SaveFile.nMaxFile
    SaveFile.lpstrInitialDir = InitialFolder
    SaveFile.lpstrTitle = Title
    SaveFile.flags = flags
    '
    l = GetSaveFileName(SaveFile)
    If l = 0 Then
        FileDialogSpec = "none"
        FileDialogFolder = ""
        FileDialogName = ""
        FileDialogSuccessful = False
    Else
        FileDialogSpec = Trim$(sLeftToNull(SaveFile.lpstrFile))
        FileDialogFolder = Left$(FileDialogSpec, InStrRev(FileDialogSpec, "\"))
        FileDialogName = Mid$(FileDialogSpec, InStrRev(FileDialogSpec, "\") + 1)
        FileDialogSuccessful = True
    End If
End Sub

Public Sub ShowPrinterDialog(hWndOwner As Long, Optional PrintFlags As PrintDialogFlags)
    Dim PrintDlg As PrintDialogType
    Dim DevMode As DeviceModeType
    Dim DevName As DeviceNamesType
    Dim lpDevMode As Long
    Dim lpDevName As Long
    Dim l As Long
    Dim objPrinter As Printer
    Dim NewPrinterName As String
    '
    ' Use PrintDialog to get the handle to a memory block with DevMode and DevName structures.
    PrintDlg.lStructSize = Len(PrintDlg)
    PrintDlg.hWndOwner = hWndOwner
    PrintDlg.flags = PrintFlags
    '
    ' Set the current orientation and duplex setting.
    On Error Resume Next
    DevMode.dmDeviceName = Printer.DeviceName
    DevMode.dmSize = Len(DevMode)
    DevMode.dmFields = DM_ORIENTATION Or DM_DUPLEX
    DevMode.dmPaperWidth = Printer.Width
    DevMode.dmOrientation = Printer.Orientation
    DevMode.dmPaperSize = Printer.PaperSize
    DevMode.dmDuplex = Printer.Duplex
    On Error GoTo 0
    '
    ' Allocate memory for the initialization hDevMode structure and copy the settings gathered above into this memory.
    PrintDlg.hDevMode = GlobalAlloc(GMEM_MOVEABLE Or GMEM_ZEROINIT, Len(DevMode))
    lpDevMode = GlobalLock(PrintDlg.hDevMode)
    CopyMemory ByVal lpDevMode, DevMode, Len(DevMode)
    l = GlobalUnlock(PrintDlg.hDevMode)
    '
    ' Set the current driver, device, and port name strings.
    DevName.wDriverOffset = 8
    DevName.wDeviceOffset = DevName.wDriverOffset + 1 + Len(Printer.DriverName)
    DevName.wOutputOffset = DevName.wDeviceOffset + 1 + Len(Printer.Port)
    DevName.wDefault = 0
    DevName.extra = Printer.DriverName & Chr(0) & Printer.DeviceName & Chr(0) & Printer.Port & Chr(0)
    '
    'Allocate memory for the initial hDevName structure and copy the settings gathered above into this memory.
    PrintDlg.hDevNames = GlobalAlloc(GMEM_MOVEABLE Or GMEM_ZEROINIT, Len(DevName))
    lpDevName = GlobalLock(PrintDlg.hDevNames)
    CopyMemory ByVal lpDevName, DevName, Len(DevName)
    l = GlobalUnlock(lpDevName)
    '
    ' Call the print dialog and let the user make changes.
    If PrintDialog(PrintDlg) <> 0 Then
        ' First, get the DevName structure.
        lpDevName = GlobalLock(PrintDlg.hDevNames)
        CopyMemory DevName, ByVal lpDevName, 45
        l = GlobalUnlock(lpDevName)
        ' Next, get the DevMode structure and set the printer properties appropriately.
        lpDevMode = GlobalLock(PrintDlg.hDevMode)
        CopyMemory DevMode, ByVal lpDevMode, Len(DevMode)
        l = GlobalUnlock(PrintDlg.hDevMode)
        NewPrinterName = UCase$(Left$(DevMode.dmDeviceName, InStr(DevMode.dmDeviceName, Chr$(0)) - 1))
        If Printer.DeviceName <> NewPrinterName Then
            For Each objPrinter In Printers
                If UCase$(objPrinter.DeviceName) = NewPrinterName Then
                    ' Set the printer for VB.
                    Set Printer = objPrinter
                    Exit For
                End If
            Next objPrinter
        End If
        '
        ' Set printer object properties according to selections made by user.
        On Error Resume Next
        Printer.Copies = DevMode.dmCopies
        Printer.Duplex = DevMode.dmDuplex
        Printer.Orientation = DevMode.dmOrientation
        Printer.PaperSize = DevMode.dmPaperSize
        Printer.PrintQuality = DevMode.dmPrintQuality
        Printer.ColorMode = DevMode.dmColor
        Printer.PaperBin = DevMode.dmDefaultSource
        On Error GoTo 0
    End If
    '
    ' Free up memory we allocated.
    GlobalFree PrintDlg.hDevNames
    GlobalFree PrintDlg.hDevMode
End Sub

Public Function BrowseForFolder(hWndOwner As Long) As String
    Dim lpIDList As Long
    Dim sBuffer As String
    Dim tBrowseInfo As BrowseInfo
    '
    tBrowseInfo.hOwner = hWndOwner
    tBrowseInfo.lpszTitle = "Browse For Folder"
    tBrowseInfo.ulFlags = BIF_RETURNONLYFSDIRS + BIF_DONTGOBELOWDOMAIN
    lpIDList = SHBrowseForFolder(tBrowseInfo)
    If lpIDList <> 0 Then
        sBuffer = Space(MAX_PATH)
        SHGetPathFromIDList lpIDList, sBuffer
        BrowseForFolder = Left$(sBuffer, InStr(sBuffer, vbNullChar) - 1)
    End If
End Function

Public Function BrowseForNetworkFolder(hWndOwner As Long, Optional bNewDialog As Boolean = True, Optional bNoNewFolder As Boolean = True) As String
    ' Returns only a valid shared folder on a network server or workstation.
    Dim bi As BrowseInfo
    Dim pidl As Long
    Dim sPath As String
    Dim attr As Long
    '
    ' Obtain the pidl to the special folder 'Network'
    If SHGetSpecialFolderLocation(hWndOwner, CSIDL_NETWORK, pidl) = 0 Then
        ' Fill in the required members, limiting the Browse to the network by specifying the returned pidl as pidlRoot.
        bi.hOwner = hWndOwner
        bi.pidlRoot = pidl
        bi.pszDisplayName = Space$(MAX_PATH)
        bi.lpszTitle = "Select a network folder."
        bi.ulFlags = BIF_RETURNONLYFSDIRS
        If bNewDialog Then bi.ulFlags = bi.ulFlags Or BIF_NEWDIALOGSTYLE
        If bNoNewFolder Then bi.ulFlags = bi.ulFlags Or BIF_NONEWFOLDERBUTTON
        ' Show the browse dialog and return the PIDL for the selected folder
        pidl = SHBrowseForFolder(bi)
        If pidl <> 0 Then
            ' Got a PIDL .. is it valid?
            sPath = Space$(MAX_PATH)
            If SHGetPathFromIDList(ByVal pidl, ByVal sPath) Then
                ' Trim any null characters.
                sPath = Left$(sPath, lstrlenW(StrPtr(sPath)))
            Else
                ' A server selected.
                sPath = "\\" & bi.pszDisplayName
            End If
            On Error Resume Next
            attr = GetAttr(sPath)
            ' Make sure a folder was selected and not some other object.
            If (attr And 16) = 16 Then BrowseForNetworkFolder = sPath
        End If
        Call CoTaskMemFree(pidl)
    End If
End Function

Public Function BrowseForNetworkComputer(hWndOwner As Long) As String
    ' Returns only a valid network server or workstation (does not display the shares).
    Dim bi As BrowseInfo
    Dim pidl As Long
    Dim sPath As String
    '
    If SHGetSpecialFolderLocation(hWndOwner, CSIDL_NETWORK, pidl) = 0 Then
        ' Fill in the required members
        bi.hOwner = hWndOwner
        bi.pidlRoot = pidl
        bi.pszDisplayName = Space$(MAX_PATH)
        bi.lpszTitle = "Select a network computer."
        bi.ulFlags = BIF_BROWSEFORCOMPUTER
        pidl = SHBrowseForFolder(bi)
        If pidl <> 0 Then
            ' A machine is selected. Although a valid pidl is returned, SHGetPathFromIDList only return
            ' paths to valid file system objects, of which a networked machine is not. However, the
            ' BROWSEINFO displayname member does contain the selected item, which we return.
            BrowseForNetworkComputer = "\\" & bi.pszDisplayName
            Call CoTaskMemFree(pidl)
        End If  'If pidl
    End If  'If SHGetSpecialFolderLocation
End Function

